<?php
defined('BASEPATH') OR exit('No direct script access allowed');

require APPPATH . 'libraries/REST_Controller.php';
     
class Auth_user extends REST_Controller {

	function __construct() 
	{
		header('Content-type: application/json');
        header("Access-Control-Allow-Origin: *");
        header("Access-Control-Allow-Methods: GET, POST");
        header("Access-Control-Allow-Headers: Content-Type, Content-Length, Accept-Encoding, x-api-key , user-id , token");
		
        parent::__construct();
		$this->load->model('User_model','user');
    }
	
    var $auth_key = "diaspora@2020";

	public function index_get()
	{
		$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
	}
	
	public function index_post()
	{
		$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
	}
	
    public function check_auth_key()
	{
        $auth_key  = $this->input->get_request_header('x-api-key', TRUE);
        if($auth_key == $this->auth_key){
            return true;
        }else{
            return false;
        }
    }
	
	public function check_auth_token()
    {
        $users_id = $this->input->get_request_header('user-id', TRUE);
        $token = $this->input->get_request_header('token', TRUE);
		
        $q = $this->db->select('expire_time')
						->from('tbl_users_authentication')
						->where('user_id',$users_id)
						->where('token',$token)
						->get()
						->row();
        if($q == "")
		{
			return array('response' => 0, 'status' => FALSE, 'message' => 'Accès non autorisé.');			
        } 
		else 
		{
            $today_date = date("Y-m-d H:i:s"); 
            if($q->expire_time < $today_date)
			{
				return array('response' => 1, 'status' => FALSE, 'message' => 'Votre session est terminée.');					
            } 
			else 
			{
				$login_time = date("Y-m-d H:i:s");
				$expired_time = date("Y-m-d H:i:s", strtotime('+12 hours'));
				
				$res_2 = $this->user->UserAuthInfo($users_id,$token,$login_time,$expired_time);
				
				return array('response' => 2, 'status' => TRUE, 'message' => 'OK');					
            }
        }
    }
	
	public function check_subscription()
	{
        $user_id = $this->input->get_request_header('user-id', TRUE);
		$subs_status = $this->user->GetSubscriptionStatus($user_id);
		
		if(!$subs_status){
			return array('response' => 0, 'status' => FALSE, 'message' => "Abonnement obligatoire.");	
		}else{
			if($subs_status->expire_date < date("Y-m-d H:i:s")){
				return array('response' => 0, 'status' => FALSE, 'message' => "Votre plan d'abonnement a expiré.");	
			}else{
				return array('response' => 1, 'status' => TRUE, 'expire_date'=>$subs_status->expire_date, 'message' => "OK");		
			}
		}
        
    }
	
	public function fcm_notification($sender_id,$reciever_id,$title,$body,$identity)
	{
		$uinfo = $this->user->GetUserDeviceTokenInfo($reciever_id);
		// Sending Notification
		if (!empty($uinfo->token))
		{
		  $fields = array(
			  'to' => $uinfo->token,
			  'notification' => array(
						  "title" => $title,
						  "body" => $body,
						  "icon" => "assets/weli_logo.png",
						  "sound" => "mySound",
						  "color" => "#f4d890",
						  "click_action" => "FCM_PLUGIN_ACTIVITY"
						  ),
				'data' => array(
				"title" => $title,
				"body" => $body,
				"sender_id" => $sender_id,
				"reciever_id" => $reciever_id,
				"noti_identity" => $identity
				)
		  );
		  
		  $fields = json_encode ( $fields );
		  
		  $headers = array (
			  'Authorization: key='._FBKEY,
			  'Content-Type: application/json'
		  );
		  $ch = curl_init ();
		  curl_setopt ( $ch, CURLOPT_URL, _FBAPI);
		  curl_setopt ( $ch, CURLOPT_POST, true );
		  curl_setopt ( $ch, CURLOPT_HTTPHEADER, $headers );
		  curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, true );
		  curl_setopt ( $ch, CURLOPT_POSTFIELDS, $fields );
		  curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
		  $result = curl_exec ( $ch );
		  curl_close ( $ch );
		}
	}

	public function registration_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST')
		{
			$this->response(
							[
								'status' => FALSE,
								'message' => 'Méthode non autorisée.'
							] ,REST_Controller::HTTP_OK
							);
		} 
		else 
		{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				// print_r($getpost); die;
				
				$first_name = $getpost->first_name;
				$last_name = $getpost->last_name;
		        $email = $getpost->email;
		        // $password = $getpost->password;
		        $phone = $getpost->phone;
		        $address = $getpost->address;
				$type = $getpost->type;
				if(isset($getpost->platform)){
					$platform = $getpost->platform;
				}else{
					$platform = 'app';
				}
		        
				
				if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{ 
					// check email existance
					$res_0 = $this->user->CheckExistance($email);
					if($res_0 > 0){
						
						$user_info = $this->user->GetUserData($email,'email');
						
						$this->response(
									[
										'user_info' => $user_info,
										'status' => FALSE,
										"message" => "Le numéro d'identification du courrier électronique existe déjà."
									] ,REST_Controller::HTTP_OK
								); 
					}else{
						
						$DataArray = array(
											'first_name' => $first_name,
											'last_name	' => $last_name,
											'email' => $email,
											'type' => $type,
											'phone_no' => $phone,
											'address' => $address,
											'platform' => $platform,
											'created' => date("Y-m-d H:i:s"),
											'updated' => date("Y-m-d H:i:s")
										  );
						
						$res_0 = $this->user->AddUser($DataArray);
						if($res_0 > 0){
							
							$user_info = $this->user->GetUserData($res_0,'id');
							// registration : OK
							$this->response(
									[
										'user_info' => $user_info,
										'status' => TRUE,
										"message" => "La demande d'enregistrement a été soumise avec succès."
									] ,REST_Controller::HTTP_OK
								); 
						}else{
							// registration : NOT OK
							$this->response(
									[
										'status' => FALSE,
										"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'une erreur de serveur."
									] ,REST_Controller::HTTP_OK
								); 
						}
						
					}
				}  
				else 
				{ 
					// email format checking : not ok
					$this->response(
								[
									'status' => FALSE,
									"message" => "Le format du courrier électronique n'est pas valide."
								] ,REST_Controller::HTTP_OK
								); 
				} 
			}
		}
	}
	
	public function login_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST')
		{
			$this->response(
							[
								'status' => FALSE,
								'message' => 'Méthode non autorisée.'
							] ,REST_Controller::HTTP_OK
							);
		} 
		else 
		{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
		        $email = $getpost->email;
				$password = $getpost->password;
		        $device_token = $getpost->device_token;
				
				if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{ 
					// check email existance
					$res_0 = $this->user->CheckExistance($email);
					if($res_0 == 0){
						$this->response(
									[
										'status' => FALSE,
										"message" => "Le numéro d'identification du courrier électronique n'existe pas."
									] ,REST_Controller::HTTP_OK
								); 
					}else{
						// get user login details
						$res_1 = $this->user->GetUserData($email,'email');
						
						if($res_1->is_email_verify == 0){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											"message" => "Veuillez d'abord vérifier votre adresse électronique."
										] ,REST_Controller::HTTP_OK
									);
						}else if($res_1->is_account_verify == 0){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											"message" => "Votre compte n'est pas encore activé."
										] ,REST_Controller::HTTP_OK
									);
						}else if($res_1->password == '' || $res_1->password == null){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											// "message" => "Veuillez d'abord définir votre mot de passe.",
											"message" => "Votre mot de passe a déjà été défini sur votre adresse électronique enregistrée."
										] ,REST_Controller::HTTP_OK
									);
						}else{
							if(strcmp(md5($password),$res_1->password) == 0){
							
								$token = crypt(substr( md5(rand()), 0, 7),substr( md5(rand()), 0, 7));
								$login_time = date("Y-m-d H:i:s");
								$expired_time = date("Y-m-d H:i:s", strtotime('+12 hours'));
								
								// check user profile completion and document completion
								$user_profile_completion = false;
								if($res_1->postal_code && $res_1->city){
									$user_profile_completion = true;
								}else{
									$user_profile_completion = false;
								}
								
								$service_provider_profile_completion = false;
								if($res_1->postal_code && $res_1->city && $res_1->company_name && $res_1->field_area && $res_1->siret && $res_1->website){
									$service_provider_profile_completion = true;
								}else{
									$service_provider_profile_completion = false;
								}
								
								$doc_upload_completion = $this->user->IsUserUploadDocument($res_1->id);
									
									
								// Insert OR update user authentication details
								$res_2 = $this->user->UserAuthInfo($res_1->id,$token,$login_time,$expired_time);
								$this->user->UserDeviceTokenUpdate($res_1->id,$device_token);
								
								if($res_2){
									$this->response(
										[
											'pre_url' => base_url(),
											'user_profile_completion' => $user_profile_completion,
											'service_provider_profile_completion' => $service_provider_profile_completion,
											'doc_upload_completion' => $doc_upload_completion,
											'user_info' => $res_1,
											'user_id' => $res_1->id,
											'token' => $token,
											'status' => TRUE,
											"message" => "Connexion réussie."
										] ,REST_Controller::HTTP_OK
									);
								}else{
									$this->response(
										[
											'status' => FALSE,
											"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'un problème de serveur."
										] ,REST_Controller::HTTP_OK
									);
								}
								
							}else{
								$this->response(
										[
											'status' => FALSE,
											"message" => "Le mot de passe est incorrect."
										] ,REST_Controller::HTTP_OK
									);
							}
						}
					}
				}  
				else 
				{ 
					// email format checking : not ok
					$this->response(
								[
									'status' => FALSE,
									"message" => "Format de courrier électronique non valide."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function logout_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$users_id = $this->input->get_request_header('user-id', TRUE);
				$token = $this->input->get_request_header('token', TRUE);
				
				$res_1 = $this->user->LogoutMe($users_id,$token);
				if($res_1){
					$this->response(
							[
								'status' => TRUE,
								"message" => "Déconnexion réussie."
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Erreur de déconnexion."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function forgotpassword_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$email = $getpost->email;
				
				if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{ 
					// check email existance
					$res_0 = $this->user->CheckExistance($email);
					if($res_0 == 0){
						$this->response(
									[
										'status' => FALSE,
										"message" => "Le numéro d'identification du courrier électronique n'existe pas."
									] ,REST_Controller::HTTP_OK
								); 
					}else{
						// get user login details
						$res_1 = $this->user->GetUserData($email,'email');
						
						if($res_1->is_email_verify == 0){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											"message" => "Veuillez d'abord vérifier votre adresse électronique."
										] ,REST_Controller::HTTP_OK
									);
						}else if($res_1->is_account_verify == 0){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											"message" => "Votre compte n'est pas encore activé."
										] ,REST_Controller::HTTP_OK
									);
						}else{
							// send user account password reset link
							$base64_userid = base64_encode($res_1->id);
							$url = BASE_URL().'action/forgotpassword?uid='.$base64_userid;
							// print_r($url); die;
							
							$this->user->ResetPasswordStatus($res_1->id,1);
							
							$this->load->library('My_PHPMailer');
					
							$body = '<head></head>';
							$body .= '<body class="clean-body" style="margin: 0;padding: 0;-webkit-text-size-adjust: 100%;">';
							$body .= '<table class="nl-container" style="border-collapse: collapse;table-layout: fixed;border-spacing: 0;mso-table-lspace: 0pt;mso-table-rspace: 0pt;vertical-align: top;min-width: 320px;Margin: 0 auto;width: 100%" cellpadding="0" cellspacing="0">';
							$body .= '<tbody><tr style="vertical-align: top"><td style="word-break: break-word;border-collapse: collapse !important;vertical-align: top"><div style="background-color:transparent;">';
							$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
							$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
							$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
							$body .= '<div style="background-color: transparent; width: 100% !important;">';
							$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:5px; padding-bottom:5px; padding-right: 0px; padding-left: 0px;">';
							$body .= '</div></div></div></div></div></div>    ';
							$body .= '<div style="background-color:transparent;">';
							$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
							$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
							$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
							$body .= '<div style="background-color: transparent; width: 100% !important;">';
							$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:20px; padding-bottom:15px; padding-right: 0px; padding-left: 0px;">';
							$body .= '<div class="">';
							$body .= '<div style="color:#555555;line-height:120%;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif; padding-right: 10px; padding-left: 10px; padding-top: 10px; padding-bottom: 10px;">';
							$body .= '<div style="font-size:12px;line-height:14px;color:#555555;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif;text-align:left;"><p style="margin: 0;font-size: 14px;line-height: 17px;text-align: center"><span style="font-size: 24px; line-height: 28px;"><strong>';
							// $body .= 'Your password reset link :';
							$body .= 'Votre lien de réinitialisation du mot de passe :';
							$body .= '</strong></span><br></p></div>';	
							$body .= '</div></div>';
							$body .= '<a href="'.$url.'" target="_new">'.$url.'</a>';
							$body .= '</div></div></div></div></div></div>';    
							$body .= '</td></tr></tbody></table></body></html>';
							
							$mail = new PHPMailer();
							$mail->IsSMTP();
							$mail->SMTPDebug = 1;
							$mail->SMTPAuth = true;
							$mail->SMTPSecure = 'ssl';
							$mail->Host = "mail.curzenncloud.fr";
							$mail->Port = 465; // or 587
							$mail->IsHTML(true);
							$mail->Username = "smtp.weli@curzenncloud.fr";
							$mail->Password = "N)kGea1KNxan";
							$mail->SetFrom('smtp.weli@curzenncloud.fr');
							$mail->Subject = "Forgot Password - Weli";
							$mail->Body = $body;
							$mail->AddAddress($email);

							if($mail->Send()){
								$this->response(
												[
													'status' => TRUE,
													// 'message' => 'Password reset link has been sent on your email address.'
													'message' => 'Un lien de réinitialisation du mot de passe a été envoyé sur votre adresse électronique.'
												] ,REST_Controller::HTTP_OK
												); 
							}else{
								$this->response(
												[
													'status' => FALSE,
													"message" => "Désolé ! Nous ne pouvons pas envoyer le lien de réinitialisation du mot de passe en raison d'une erreur de serveur."
												] ,REST_Controller::HTTP_OK
												); 
							}
						}
					}
				}  
				else 
				{ 
					// email format checking : not ok
					$this->response(
								[
									'status' => FALSE,
									"message" => "Format de courrier électronique non valide."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function Setpassword_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $getpost->user_id;
				$password = $getpost->password;
				
				if($password) 
				{ 
					
					$user_info = $this->user->GetUserData($user_id,'id');
											
					if($user_info->is_email_verify == 0){
						$this->response(
									[
										'user_info' => $user_info,
										'status' => FALSE,
										"message" => "Veuillez d'abord vérifier votre adresse électronique."
									] ,REST_Controller::HTTP_OK
								);
					}else if($user_info->is_account_verify == 0){
						$this->response(
									[
										'user_info' => $user_info,
										'status' => FALSE,
										"message" => "Votre compte n'est pas encore activé."
									] ,REST_Controller::HTTP_OK
								);
					}else{
						
						$res_0 = $this->user->SetPassword($user_id,$password);
						if($res_0){
							$this->response(
								[
									'user_info' => $user_info,
									'status' => TRUE,
									"message" => "Mot de passe mis à jour avec succès."
								] ,REST_Controller::HTTP_OK
							); 
						}else{
							$this->response(
									[
										'status' => FALSE,
										"message" => "Désolé ! Nous ne pouvons pas mettre à jour votre mot de passe en raison d'une erreur du serveur."
									] ,REST_Controller::HTTP_OK
									); 
						}
					}
				}  
				else 
				{ 
					$this->response(
								[
									'status' => FALSE,
									"message" => "Veuillez entrer le mot de passe."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function verifyemail_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $getpost->user_id;
				$email = $getpost->email;
				
				if($email) 
				{ 
					if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
					{
						$user_info = $this->user->GetUserData($user_id,'id');
						if($user_info->email == $email){
							
							if($user_info->is_email_verify == 1){
								$this->response(
										[
											'status' => TRUE,
											"message" => "Courriel déjà vérifié."
										] ,REST_Controller::HTTP_OK
										); 
							}else{
								
								$base64_userid = base64_encode($user_id);
								$url = BASE_URL().'action/emailverification?uid='.$base64_userid;
								// print_r($url); die;
								
								$this->load->library('My_PHPMailer');
						
								$body = '<head></head>';
								$body .= '<body class="clean-body" style="margin: 0;padding: 0;-webkit-text-size-adjust: 100%;background-color: #CCCCCC">';
								$body .= '<table class="nl-container" style="border-collapse: collapse;table-layout: fixed;border-spacing: 0;mso-table-lspace: 0pt;mso-table-rspace: 0pt;vertical-align: top;min-width: 320px;Margin: 0 auto;background-color: #CCCCCC;width: 100%" cellpadding="0" cellspacing="0">';
								$body .= '<tbody><tr style="vertical-align: top"><td style="word-break: break-word;border-collapse: collapse !important;vertical-align: top"><div style="background-color:transparent;">';
								$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
								$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
								$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
								$body .= '<div style="background-color: transparent; width: 100% !important;">';
								$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:5px; padding-bottom:5px; padding-right: 0px; padding-left: 0px;">';
								$body .= '</div></div></div></div></div></div>    ';
								$body .= '<div style="background-color:transparent;">';
								$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
								$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
								$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
								$body .= '<div style="background-color: transparent; width: 100% !important;">';
								$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:20px; padding-bottom:15px; padding-right: 0px; padding-left: 0px;">';
								$body .= '<div class="">';
								$body .= '<div style="color:#555555;line-height:120%;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif; padding-right: 10px; padding-left: 10px; padding-top: 10px; padding-bottom: 10px;">';
								$body .= '<div style="font-size:12px;line-height:14px;color:#555555;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif;text-align:left;"><p style="margin: 0;font-size: 14px;line-height: 17px;text-align: center"><span style="font-size: 24px; line-height: 28px;"><strong>';
								// $body = 'Click on below button to verify your email address :';
								$body = 'Cliquez sur le lien ci-dessous pour vérifier votre adresse électronique :';
								$body .= '</strong></span><br></p></div>';	
								$body .= '</div></div>';
								$body .= '<a href="'.$url.'" target="_new">'.$url.'</a>';
								$body .= '</div></div></div></div></div></div>';    
								$body .= '</td></tr></tbody></table></body></html>';
								
								$mail = new PHPMailer();
								$mail->IsSMTP();
								$mail->SMTPDebug = 1;
								$mail->SMTPAuth = true;
								$mail->SMTPSecure = 'ssl';
								$mail->Host = "mail.curzenncloud.fr";
								$mail->Port = 465; // or 587
								$mail->IsHTML(true);
								$mail->Username = "smtp.weli@curzenncloud.fr";
								$mail->Password = "N)kGea1KNxan";
								$mail->SetFrom('smtp.weli@curzenncloud.fr');
								$mail->Subject = "Email Verification - Weli";
								// $mail->Subject = "Vérification des courriers électroniques - Weli";
								$mail->Body = $body;
								$mail->AddAddress($email);

								if($mail->Send()){
									$this->response(
													[
														'status' => TRUE,
														// 'message' => 'Email verification link has been sent on your email address.'
														'message' => 'Un lien de vérification a été envoyé sur votre adresse électronique.'
													] ,REST_Controller::HTTP_OK
													); 
								}else{
									$this->response(
													[
														'status' => FALSE,
														"message" => "Désolé ! Nous ne pouvons pas envoyer le lien de réinitialisation du mot de passe en raison d'une erreur de serveur."
													] ,REST_Controller::HTTP_OK
													); 
								}
								
							}
							
						}else{
							$this->response(
										[
											'status' => FALSE,
											"message" => "Correspondance des courriels."
										] ,REST_Controller::HTTP_OK
									);
						}
					}  
					else 
					{ 
						$this->response(
									[
										'status' => FALSE,
										"message" => "Format de courrier électronique non valide."
									] ,REST_Controller::HTTP_OK
									); 
					}
				}  
				else 
				{ 
					$this->response(
								[
									'status' => FALSE,
									"message" => "Adresse électronique requise."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function check_account_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $getpost->user_id;
				$user_info = $this->user->GetUserData($user_id,'id');
				if($user_info->is_account_verify == 1){
					$this->response(
									[
										'status' => TRUE,
										"message" => "Votre compte est vérifié."
									] ,REST_Controller::HTTP_OK
									);
				}else{
					$this->response(
									[
										'status' => FALSE,
										"message" => "Votre compte n'est toujours pas vérifié."
									] ,REST_Controller::HTTP_OK
									);
				}
			}
		}
	}
	
	public function myprofile_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$user_id = $this->input->get_request_header('user-id', TRUE);
				$my_profile = $this->user->GetUserData($user_id,'id');
				$this->response(
							[
								'pre_url' => base_url(),
								'my_profile' => $my_profile,
								'status' => TRUE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			
		}
	}
	
	public function update_myprofile_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				// $getpost = json_decode(file_get_contents('php://input'));
				
				if(!is_dir("./assets/uplods/user_profile")){ 
					mkdir("./assets/uplods/user_profile", 0777, true);
				}
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$first_name = $this->input->post('first_name');
				$last_name = $this->input->post('last_name');
				$nick_name = $this->input->post('nick_name');
				$phone = $this->input->post('phone');
				$address = $this->input->post('address');
				$postal_code = $this->input->post('postal_code');
				$city = $this->input->post('city');
				
				$company_name = $this->input->post('company_name');
		        $field_area = $this->input->post('field_area');
		        $siret = $this->input->post('siret');
		        $website = $this->input->post('website');
				
				$my_profile = $this->user->GetUserData($user_id,'id');
				
				$profile_url = $my_profile->profile_url;
				
				// print_r($_POST); print_r($_FILES); die;
				
				if(count($_FILES) > 0)
				{
					$profile = $_FILES['profile_pic']['name'];
					
					$encrypt_filename = time().$profile;
					
					$config = array(
								'upload_path' => "./assets/uplods/user_profile",
								'allowed_types' => "gif|jpg|png|jpeg|bmp",
								// 'allowed_types' => "*",
								'overwrite' => TRUE,
								'encrypt_name' => TRUE,
								// 'max_size' => "3072000",
								'file_name' => $encrypt_filename
								);
					
					$this->load->library('upload',$config);
					$this->upload->initialize($config);
					
					if (!$this->upload->do_upload('profile_pic'))
					{
						$this->response(
								[
									'status' => FALSE,
									'message' => $this->upload->display_errors()
								] ,REST_Controller::HTTP_OK
								);
					}
					else
					{
						$pimage = $this->upload->data();
						$profile_url = "assets/uplods/user_profile/".$pimage['file_name'];
						
						if(file_exists($my_profile->profile_url)) 
						{   
							chmod($my_profile->profile_url, 0777);
							unlink($my_profile->profile_url);                         
						}
					}
				}
				
				$dataArray = array(
									'first_name' => $first_name,
									'last_name' => $last_name,
									'profile_url' => $profile_url,
									'nickname' => $nick_name,
									'phone_no' => $phone,
									'address' => $address,
									'postal_code' => $postal_code,
									'city' => $city,
									'company_name' => $company_name,
									'field_area' => $field_area,
									'siret' => $siret,
									'website' => $website,
									'updated' => date("Y-m-d H:i:s")
								   );
				
				$res_0 = $this->user->UpdateUserData($user_id,$dataArray);
				if($res_0){
					$my_profile = $this->user->GetUserData($user_id,'id');
					$this->response(
								[
									'pre_path' => base_url(),
									'my_profile' => $my_profile,
									'status' => TRUE,
									"message" => "Profil mis à jour avec succès."
								] ,REST_Controller::HTTP_OK
								);
				}else{
					$my_profile = $this->user->GetUserData($user_id,'id');
					$this->response(
								[
									'pre_path' => base_url(),
									'my_profile' => $my_profile,
									'status' => FALSE,
									"message" => "Désolé ! Nous ne pouvons pas mettre à jour le profil en raison d'une erreur du serveur."
								] ,REST_Controller::HTTP_OK
								);
				}
			}
			
		}
	}
	
	public function update_password_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
							
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$password = $getpost->password;
				$offer = $getpost->offer;
				
				$dataArray = array(
									'password' => md5($password),
									'offer' => $offer,
									'updated' => date("Y-m-d H:i:s")
								   );
				
				$res_0 = $this->user->UpdateUserData($user_id,$dataArray);
				if($res_0){
					$my_profile = $this->user->GetUserData($user_id,'id');
					$this->response(
								[
									'my_profile' => $my_profile,
									'status' => TRUE,
									"message" => "Profil mis à jour avec succès."
								] ,REST_Controller::HTTP_OK
								);
				}else{
					$my_profile = $this->user->GetUserData($user_id,'id');
					$this->response(
								[
									'my_profile' => $my_profile,
									'status' => FALSE,
									"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'une erreur de serveur."
								] ,REST_Controller::HTTP_OK
								);
				}
			}
		}
	}
	
	public function document_upload_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				if(!is_dir("./assets/uplods/user_documents")){ 
					mkdir("./assets/uplods/user_documents", 0777, true);
				}
				
				if(count($_FILES) > 0)
				{
					if(count($_FILES) == 10)
					{
						if(
							$_FILES['doc_1']['name'] && 
							$_FILES['doc_2']['name'] && 
							$_FILES['doc_3']['name'] && 
							$_FILES['doc_4']['name'] && 
							$_FILES['doc_5']['name'] && 
							$_FILES['doc_6']['name'] && 
							$_FILES['doc_7']['name'] && 
							$_FILES['doc_8']['name'] && 
							$_FILES['doc_9']['name'] && 
							$_FILES['doc_10']['name']
						){
							
							for($i=1; $i<=10; $i++)
							{
								$doc = $_FILES['doc_'.$i];
								
								$doc_name = $_FILES['doc_'.$i]['name'];
								$doc_type_0 = $_FILES['doc_'.$i]['type'];
								$doc_type_1 = substr($_FILES['doc_'.$i]['type'], strpos($_FILES['doc_1']['type'], "/") + 1);
								$doc_tmp_name = $_FILES['doc_'.$i]['tmp_name'];
								$doc_size = $_FILES['doc_'.$i]['size'];
														
								$doc = $_FILES['doc_'.$i]['name'];
								
								$encrypt_filename = $i.'_'.time().$doc;
								
								$config = array(
											'upload_path' => "./assets/uplods/user_documents",
											// 'allowed_types' => $doc_type_1,
											// 'allowed_types' => "gif|jpg|png|jpeg|bmp",
											'allowed_types' => "*",
											'overwrite' => TRUE,
											'encrypt_name' => TRUE,
											// 'max_size' => "3072000",
											'file_name' => $encrypt_filename
											);
								
								$this->load->library('upload',$config);
								$this->upload->initialize($config);
								
								if (!$this->upload->do_upload('doc_'.$i))
								{
									$this->response(
											[
												'status' => FALSE,
												'message' => $this->upload->display_errors()
											] ,REST_Controller::HTTP_OK
											);
								}
								else
								{
									$pimage = $this->upload->data();
									
									$user_id = $this->input->get_request_header('user-id', TRUE);
									
									$dataArray = array(
														'user_id' => $user_id,
														'doc_no' => $i,
														'doc_path' => "assets/uplods/user_documents/".$pimage['file_name'],
														'doc_name' => $pimage['file_name'],
														'created' => date("Y-m-d H:i:s"),
														'updated' => date("Y-m-d H:i:s")
													  );
									
									$this->user->UploadUserDocuments($dataArray);
									
									if($i == 10){
										$this->response(
											[
												'status' => TRUE,
												"message" => "Document téléchargé avec succès."
											] ,REST_Controller::HTTP_OK
											);
									}
								}
							}
							
						}else{
							$this->response(
								[
									'status' => FALSE,
									"message" => "Document mal joint. Veuillez vérifier une fois."
								] ,REST_Controller::HTTP_OK
								);
						}
					}
					else
					{
						$remain_doc = 10 - count($_FILES);
						$this->response(
							[
								'status' => FALSE,
								"message" => "Veuillez télécharger le reste du document."
							] ,REST_Controller::HTTP_OK
							);
					}
				}
				else
				{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Document requis."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function all_category_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
															
				$all_cats = $this->user->GetAllCategories();
				
				if($all_cats){
					$this->response(
							[
								'pre_url' => WELI_WEB_URL,
								'categories' => $all_cats,
								'status' => TRUE,
								'message' => 'OK'
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'categories' => '',
								'status' => FALSE,
								"message" => "Aucune catégorie trouvée."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function sub_categories_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$category_id = $getpost->category_id;
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$all_subcats = $this->user->GetSubCategoriesByCategory($category_id,$user_id);
				
				if($all_subcats){
					$this->response(
							[
								'pre_url' => WELI_WEB_URL,
								'sub_categories' => $all_subcats,
								'status' => TRUE,
								'message' => 'OK'
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'sub_categories' => '',
								'status' => FALSE,
								"message" => "Aucune sous-catégorie trouvée."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function sub_category_detail_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$sub_category_id = $getpost->sub_category_id;
				
				$subcatsinfo = $this->user->GetSubCategoryDetail($sub_category_id);
				
				if($subcatsinfo){
					$this->response(
							[
								'pre_url' => WELI_WEB_URL,
								'sub_category_info' => $subcatsinfo,
								'status' => TRUE,
								'message' => 'OK'
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'sub_category_info' => '',
								'status' => FALSE,
								"message" => "Aucune sous-catégorie trouvée."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function filter_by_subcategory_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$sub_category_id = $getpost->sub_category_id;
				
				$filters = $this->user->GetFiltersBySubcate($sub_category_id);
				
				if($filters){
					$this->response(
							[
								'filters' => $filters,
								'status' => TRUE,
								'message' => 'OK'
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'filters' => '',
								'status' => FALSE,
								"message" => "Aucun filtre trouvé."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}

	/*
	public function ad_submission_post()
	{
		if(!is_dir("./assets/uplods/ad_documents")){ 
			mkdir("./assets/uplods/ad_documents", 0777, true);
		}
		
		if(!is_dir("./assets/uplods/ad_gallery")){ 
			mkdir("./assets/uplods/ad_gallery", 0777, true);
		}
		
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$category_id = $_POST['category_id'];
				$sub_category_id = $_POST['sub_category_id'];
				$title = $_POST['title'];
				$description = $_POST['description'];
				
				$short_description = $_POST['short_description'];
				$pricing_title = $_POST['pricing_title'];
				$pricing_cost = $_POST['pricing_cost'];
				$location = $_POST['location'];
				$latitude = $_POST['latitude'];
				$longitude = $_POST['longitude'];
				$offer = $_POST['offer'];
				
				$dataArray = array(
									'user_id' => $user_id,
									'cat_id_1' => $category_id,
									'cat_id_2' => $sub_category_id,
									'title' => $title,
									'description' => $description,
									'short_description' => $short_description,
									'pricing_title' => $pricing_title,
									'pricing_cost' => $pricing_cost,
									'location' => $location,
									'latitude' => $latitude,
									'longitude' => $longitude,
									'offer' => $offer,
									'created' => date("Y-m-d"),
									'updated' => date("Y-m-d")
								  );
				
				$last_id = $this->user->ad_submit($dataArray);
				if($last_id > 0)
				{
					if(count($_FILES) > 0)
					{
						$ad_gallery = $_FILES['ad_gallery']['name'];
						$ad_gallery_count = count($ad_gallery);
						for ($pi = 0; $pi < $ad_gallery_count; $pi++) 
						{
							$config = array(
										'upload_path' => "./assets/uplods/ad_gallery",
										'allowed_types' => "*",
										'overwrite' => TRUE,
										'encrypt_name' => TRUE,
										// 'max_size' => '3072000',
										'file_name' => time().$_FILES['ad_gallery']['name'][$pi]
										);
							
							$this->load->library('upload',$config);
							$this->upload->initialize($config);
							
							if (!$this->upload->do_upload('file'))
							{
								echo json_encode(array('response' => 0, 'msg' => $this->upload->display_errors()));
								exit;
							}
							else
							{
								$pimage = $this->upload->data();

								$dataArray_1 = array(
													'image_path' => "assets/uplods/ad_gallery/".$pimage['file_name'],
													'ad_id' => $last_id,
													'user_id' => $user_id,
													'image_name' => $pimage['file_name'],
													'cat_id_1' => $category_id,
													'cat_id_2' => $sub_category_id,
													'created' => date("Y-m-d"),
													'updated' => date("Y-m-d")
												);

								$addedORnot = $this->user->UploadAdGallery($dataArray_1);	
								if($addedORnot){
									$count_images_new = $ad_gallery_count-1;
									if($count_images_new == $pi){
										
										$this->response(
														[
															'status' => TRUE,
															"message" => "soumission d'une annonce avec succès."
														] ,REST_Controller::HTTP_OK
													);	
									}
								}
							}
						}
					}
					else
					{
						$this->response(
										[
											'status' => TRUE,
											"message" => "soumission d'une annonce avec succès."
										] ,REST_Controller::HTTP_OK
									);
					}
				}
				else
				{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Une erreur s'est produite lors de la soumission d'informations publicitaires."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	*/
	
	public function ad_submission_post()
	{
		if(!is_dir("./assets/uplods/ad_documents")){ 
			mkdir("./assets/uplods/ad_documents", 0777, true);
		}
		
		if(!is_dir("./assets/uplods/ad_gallery")){ 
			mkdir("./assets/uplods/ad_gallery", 0777, true);
		}
		
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				// checking advertiser subscription plan START
				$check_subscription = $this->check_subscription();
				if($check_subscription['response'] == 0)
				{
					$this->response(
							[
								'status' => FALSE,
								'message' => $check_subscription['message']
							] ,REST_Controller::HTTP_OK
							);
				}
				else
				{
					
					$category_id = $_POST['category_id'];
					$sub_category_id = $_POST['sub_category_id'];
					
					$title = $_POST['title'];
					$description = $_POST['description'];
					$short_description = $_POST['short_description'];
					// $pricing_title = $_POST['pricing_title'];
					// $pricing_cost = $_POST['pricing_cost'];
					$location = $_POST['location'];
					$latitude = $_POST['latitude'];
					$longitude = $_POST['longitude'];
					$offer = $_POST['offer'];
					
					// print_r($_POST); print_r($_FILES);
					// die;
					
					$dataArray = array(
										'user_id' => $user_id,
										'cat_id_1' => $category_id,
										'cat_id_2' => $sub_category_id,
										'title' => $title,
										'description' => $description,
										'short_description' => $short_description,
										// 'pricing_title' => $pricing_title,
										// 'pricing_cost' => $pricing_cost,
										'location' => $location,
										'latitude' => $latitude,
										'longitude' => $longitude,
										'offer' => $offer,
										'show_till' => $check_subscription['expire_date'],
										'created' => date("Y-m-d H:i:s"),
										'updated' => date("Y-m-d H:i:s")
									  );
					
					$last_id = $this->user->ad_submit($dataArray);
					if($last_id > 0)
					{
						// Gallery upload starts
							if(isset($_FILES['ad_gallery']))
							{
								if($_FILES['ad_gallery']['name'][0]){
									$is_gallery = count($_FILES['ad_gallery']['name']);
								}else{
									$is_gallery = 0;
								}
								if($is_gallery > 0)
								{
									$ad_gallery = $_FILES['ad_gallery']['name'];
									$ad_gallery_count = count($ad_gallery);
									for ($pi = 0; $pi < $ad_gallery_count; $pi++) 
									{
										$_FILES['file']['name'] = $_FILES['ad_gallery']['name'][$pi];
										$_FILES['file']['type'] = $_FILES['ad_gallery']['type'][$pi];
										$_FILES['file']['tmp_name'] = $_FILES['ad_gallery']['tmp_name'][$pi];
										$_FILES['file']['error'] = $_FILES['ad_gallery']['error'][$pi];
										$_FILES['file']['size'] = $_FILES['ad_gallery']['size'][$pi];
										
										$config = array(
													'upload_path' => "./assets/uplods/ad_gallery",
													'allowed_types' => "*",
													'overwrite' => TRUE,
													'encrypt_name' => TRUE,
													// 'max_size' => '3072000',
													'file_name' => time().$_FILES['ad_gallery']['name'][$pi]
													);
										
										$this->load->library('upload',$config);
										$this->upload->initialize($config);
										
										if (!$this->upload->do_upload('file'))
										{
											echo json_encode(array('response' => 0, 'msg' => $this->upload->display_errors()));
											exit;
										}
										else
										{
											$pimage = $this->upload->data();

											$dataArray_1 = array(
																'image_path' => "assets/uplods/ad_gallery/".$pimage['file_name'],
																'ad_id' => $last_id,
																'user_id' => $user_id,
																'image_name' => $pimage['file_name'],
																'cat_id_1' => $category_id,
																'cat_id_2' => $sub_category_id,
																'created' => date("Y-m-d H:i:s"),
																'updated' => date("Y-m-d H:i:s")
															);

											$addedORnot = $this->user->UploadAdGallery($dataArray_1);
											/*
											if($addedORnot){
												$count_images_new = $ad_gallery_count-1;
												if($count_images_new == $pi){
													
													$this->response(
																	[
																		'status' => TRUE,
																		"message" => "Annonce soumise avec succès."
																	] ,REST_Controller::HTTP_OK
																);	
												}
											}
											*/
										}
									}
								}
							}
						// Gallery upload ends
						
						
						// print_r($_FILES); die;
						
						// Documents upload starts
							if(isset($_FILES['ad_documents']))
							{
								if($_FILES['ad_documents']['name'][0]){
									$is_document = count($_FILES['ad_documents']['name']);
								}else{
									$is_document = 0;
								}
								if($is_document > 0)
								{
									$ad_documents = $_FILES['ad_documents']['name'];
									$ad_documents_count = count($ad_documents);
									for ($pi = 0; $pi < $ad_documents_count; $pi++) 
									{
										$_FILES['file']['name'] = $_FILES['ad_documents']['name'][$pi];
										$_FILES['file']['type'] = $_FILES['ad_documents']['type'][$pi];
										$_FILES['file']['tmp_name'] = $_FILES['ad_documents']['tmp_name'][$pi];
										$_FILES['file']['error'] = $_FILES['ad_documents']['error'][$pi];
										$_FILES['file']['size'] = $_FILES['ad_documents']['size'][$pi];
										
										$config = array(
													'upload_path' => "./assets/uplods/ad_documents",
													'allowed_types' => "*",
													'overwrite' => TRUE,
													'encrypt_name' => TRUE,
													// 'max_size' => '3072000',
													'file_name' => time().$_FILES['ad_documents']['name'][$pi]
													);
										
										$this->load->library('upload',$config);
										$this->upload->initialize($config);
										
										if (!$this->upload->do_upload('file'))
										{
											echo json_encode(array('response' => 0, 'msg' => $this->upload->display_errors()));
											exit;
										}
										else
										{
											$pimage = $this->upload->data();

											$dataArray_1 = array(
																'ad_id' => $last_id,
																'user_id' => $user_id,
																'doc_path' => "assets/uplods/ad_documents/".$pimage['file_name'],
																'doc_title' => $_POST['doc_title'][$pi],
																// 'doc_title' => $pi,
																'doc_name' => $pimage['file_name'],
																'cat_id_1' => $category_id,
																'cat_id_2' => $sub_category_id,
																'created' => date("Y-m-d H:i:s"),
																'updated' => date("Y-m-d H:i:s")
															);

											$addedORnot = $this->user->UploadAdDocuments($dataArray_1);
										}
									}
								}
							}
						// Documents upload ends
						
						// Dynamic form data submission starts
							$post_count = count($_POST)-11; $pcount = 0;
							if($post_count > 0)
							{
								foreach($_POST as $key=>$val)
								{
									if(
										$key != 'category_id' &&
										$key != 'sub_category_id' &&
										$key != 'title' &&
										$key != 'description' &&
										$key != 'short_description' &&
										$key != 'location' &&
										$key != 'latitude' &&
										$key != 'longitude' &&
										$key != 'offer' &&
										$key != 'doc_title'
									  )
									{
										$newArray = array(
															'cat_1' => $category_id,
															'cat_2' => $sub_category_id,
															'ad_id' => $last_id,
															'meta_key' => str_replace('_', ' ', $key),
															'meta_value' => $val,
															'created' => date("Y-m-d H:i:s"),
															'updated' => date("Y-m-d H:i:s")
														 );
														 
										$adres = $this->user->ad_detail_submit($newArray);
										if($adres){
											$pcount = $pcount+1;
											
											if($pcount == $post_count)
											{
												$this->response(
													[
														'status' => TRUE,
														"message" => "Annonce soumise avec succès."
													] ,REST_Controller::HTTP_OK
												);
											}
										}								
									}
								}
							}
							else
							{
								$this->response(
											[
												'status' => TRUE,
												"message" => "Annonce soumise avec succès."
											] ,REST_Controller::HTTP_OK
										);
							}
						// Dynamic form data submission ends
					}
					else
					{
						$this->response(
								[
									'status' => FALSE,
									"message" => "Une erreur s'est produite lors de la soumission d'informations publicitaires."
								] ,REST_Controller::HTTP_OK
								);
					}
				}
			}
		}
	}
	
	public function ad_by_catsubcat_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$category_id = $getpost->category_id;
				$sub_category_id = $getpost->sub_category_id;
				$is_offer = $getpost->is_offer; // 0 == with and winthout offer , 1 = only with offer
				$looking_for = $getpost->looking_for;
				$location = $getpost->location;
				$latitude = $getpost->latitude;
				$longitude = $getpost->longitude;
				$sorting = $getpost->sorting;
				
				$ad_list = $this->user->GetAdByCatSubCat($category_id,$sub_category_id,$is_offer,$looking_for,$latitude,$longitude,$sorting);
				
				$researchArray = array(
										'user_id' => $this->input->get_request_header('user-id', TRUE),
										'category_id' => $category_id,
										'sub_category_id' => $sub_category_id,
										'is_offer' => $is_offer,
										'looking_for' => $looking_for,
										'location' => $location,
										'latitude' => $latitude,
										'longitude' => $longitude,
										'sorting' => $sorting,
										'research_date' => date("Y-m-d H:i:s")
									  );
				$this->user->AddUserResearchInfo($researchArray);

				$new_ad_list = array();
				foreach($ad_list as $val)
				{
					$ad_gallery = $this->user->GetAdGallery($val->id);
					// $ad_documents = $this->user->GetAdDocumets($val->id);
					// $ad_user = $this->user->GetUserById($val->user_id);
					// $ad_criteria = $this->user->GetAdCriteria($val->id);
					
					$new_ad_list[] = array(
										'ad_id' => $val->id,
										'user_id' => $val->user_id,
										'cat_id_1' => $val->cat_id_1,
										'cat_id_2' => $val->cat_id_2,
										'category_name' => $val->category_name,
										'sub_category_name' => $val->sub_category_name,
										'title' => $val->title,
										'description' => $val->description,
										'short_description' => $val->short_description,
										'location' => $val->location,
										'latitude' => $val->latitude,
										'longitude' => $val->longitude,
										'offer' => $val->offer,
										'created' => $val->created,
										'updated' => $val->updated,
										'is_verified' => $val->is_verified,
										'is_favourite' => $val->is_favourite,
										'pre_path' => base_url(),
										// 'ad_criteria' => $ad_criteria,
										// 'ad_documents' => $ad_documents,
										'ad_gallery' => $ad_gallery
										// 'ad_user' => $ad_user
									);
				}
				
				// print_r($new_ad_list); die;
				
				if($new_ad_list){
					$this->response(
							[
								'ad_list' => $new_ad_list,
								'status' => TRUE,
								'message' => 'OK'
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'ad_list' => '',
								'status' => FALSE,
								"message" => "Aucune annonce trouvée."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function ad_detail_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$ad_id = $getpost->ad_id;
				
				$ad_detail = $this->user->GetAdById($ad_id);
				
				if($ad_detail){
					
					$ad_gallery = $this->user->GetAdGallery($ad_detail->id);
					// $ad_filters = $this->user->GetAdFilters($ad_detail->id);
					$ad_documents = $this->user->GetAdDocumets($ad_detail->id);
					$ad_user = $this->user->GetUserById($ad_detail->user_id);
					$ad_criteria = $this->user->GetAdCriteria($ad_detail->id);
					
					$new_ad_detail[] = array(
										'ad_id' => $ad_detail->id,
										'user_id' => $ad_detail->user_id,
										'cat_id_1' => $ad_detail->cat_id_1,
										'cat_id_2' => $ad_detail->cat_id_2,
										'category_name' => $ad_detail->category_name,
										'sub_category_name' => $ad_detail->sub_category_name,
										'title' => $ad_detail->title,
										'description' => $ad_detail->description,
										'short_description' => $ad_detail->short_description,
										'location' => $ad_detail->location,
										'latitude' => $ad_detail->latitude,
										'longitude' => $ad_detail->longitude,
										'offer' => $ad_detail->offer,
										'created' => $ad_detail->created,
										'updated' => $ad_detail->updated,
										'is_verified' => $ad_detail->is_verified,
										'pre_path' => base_url(),
										'ad_criteria' => $ad_criteria,
										'ad_gallery' => $ad_gallery,
										// 'ad_filters' => $ad_filters,
										'ad_documents' => $ad_documents,
										'ad_user' => $ad_user
									);
					
					// print_r($new_ad_detail); die;
					
					if($new_ad_detail){
						$this->response(
								[
									'ad_detail' => $new_ad_detail,
									'status' => TRUE,
									'message' => 'OK'
								] ,REST_Controller::HTTP_OK
								);
					}else{
						$this->response(
								[
									'ad_detail' => '',
									'status' => FALSE,
									"message" => "Aucune annonce trouvée."
								] ,REST_Controller::HTTP_OK
								);
					}
					
				}else{
					$this->response(
							[
								'ad_detail' => '',
								'status' => FALSE,
								"message" => "Annonce non encore vérifiée."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function add_chat_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$from_id = $getpost->from_id;
				$to_id = $getpost->to_id;
				$chat_msg = $getpost->chat_msg;
				$chat_date = date("Y-m-d H:i:s");
				
				$ui = $this->user->GetUserById($from_id);
									
				$dataArray = array(
									"from_id" => $from_id,
									"to_id" => $to_id,
									"msg" => $chat_msg,
									"msg_by" => $ui->type,
									"chat_date" => $chat_date
								  );
				
				$lastid = $this->user->add_chat($dataArray);
				if($lastid > 0){

					// PUSH NOTIFICATION STARTS
						$noti_title = $ui->first_name.' '.$ui->last_name;
						$noti_msg = $chat_msg;
						$this->fcm_notification($from_id,$to_id,$noti_title,$noti_msg,'chatting');
					// PUSH NOTIFICATION ENDS

					$chat_history = $this->user->get_chat($from_id,$to_id);
					$this->response(
						[
							'status' => TRUE,
							'chat_history' => $chat_history
						] ,REST_Controller::HTTP_OK
						);
				}else{
					$this->response(
						[
							'status' => FALSE,
							'chat_history' => ''
						] ,REST_Controller::HTTP_OK
						);
				}
			}
		}
	}
	
	public function get_chat_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$from_id = $getpost->from_id;
				$to_id = $getpost->to_id;
				
				$chat_history = $this->user->get_chat($from_id,$to_id);
				if($chat_history){
					$this->response(
						[
							'status' => TRUE,
							'chat_history' => $chat_history
						] ,REST_Controller::HTTP_OK
						);
				}else{
					$this->response(
						[
							'status' => FALSE,
							'chat_history' => []
						] ,REST_Controller::HTTP_OK
						);
			
				}
			}
		}
	}
	
	public function get_chat_users_post()
	{
		// for service provider
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>'Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $getpost->user_id;
				$user_info = $this->user->GetUserById($user_id);
				
				// if($user_info->type == 1)
				if($user_info->type == 5)
				{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Vous n'êtes pas autorisé à accéder à ces informations."
							] ,REST_Controller::HTTP_OK
							);
				}
				else
				{
					$user_list = $this->user->GetChatUsers($user_id);
					
					// $result = array();

					// foreach($user_list as $val) {
					// 	if(array_key_exists('user_id', $val)){
					// 		$result[$val['user_id']][] = $val;
					// 	}else{
					// 		$result[""][] = $val;
					// 	}
					// }
					
					if($user_list){
						$this->response(
							[
								'status' => TRUE,
								'user_list' => $user_list
							] ,REST_Controller::HTTP_OK
							);
					}else{
						$this->response(
							[
								'status' => FALSE,
								'user_list' => []
							] ,REST_Controller::HTTP_OK
							);
					}
				}
			}
		}
	}
	
	public function get_user_documents_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>'Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$user_docs = $this->user->GetUserDocsById($user_id);
				
				// print_r($user_docs); die;
				
				$this->response(
						[
							'status' => TRUE,
							'pre_url' => base_url(),
							'user_docs' => $user_docs
						] ,REST_Controller::HTTP_OK
						);
			}
		}
	}
	
	public function user_document_update_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>'Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				if(!is_dir("./assets/uplods/user_documents")){ 
					mkdir("./assets/uplods/user_documents", 0777, true);
				}
				
				// print_r($_FILES); die;
				
				if(count($_FILES) > 0)
				{
					for($i = 1; $i <= 10; $i++)
					{						
						$doc = $_FILES['doc_'.$i]['name'];
						
						if($doc)
						{								
							$encrypt_filename = time().$doc;
							
							$config = array(
										'upload_path' => "./assets/uplods/user_documents",
										'allowed_types' => "*",
										'overwrite' => TRUE,
										'encrypt_name' => TRUE,
										// 'max_size' => "3072000",
										'file_name' => $encrypt_filename
										);
							
							$this->load->library('upload',$config);
							$this->upload->initialize($config);
							
							if (!$this->upload->do_upload('doc_'.$i))
							{
								$this->response(
										[
											'status' => FALSE,
											'message' => $this->upload->display_errors()
										] ,REST_Controller::HTTP_OK
										);
							}
							else
							{
								$pimage = $this->upload->data();
																
								$dataArray = array(
													'doc_path' => "assets/uplods/user_documents/".$pimage['file_name'],
													'doc_name' => $pimage['file_name'],
													'updated' => date("Y-m-d H:i:s")
												  );
								
								$docpath = $this->user->GetUserDocumentPath($user_id,$i);
								if($docpath->doc_path)
								{
									$old_doc_path = $docpath->doc_path;
									if(file_exists($old_doc_path)){   
										chmod($old_doc_path, 0777);
										unlink($old_doc_path);                         
									}
								}
								
								$res = $this->user->UpdateUserDocuments($user_id,$i,$dataArray);
							}
						}
						
						if($i == 10){
							$this->response(
								[
									'status' => TRUE,
									"message" => "Document téléchargé avec succès."
								] ,REST_Controller::HTTP_OK
								);
						}
					}
				}
				else
				{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Document requis."
							] ,REST_Controller::HTTP_OK
							);
				}
				
			}
		}
	}
	
	public function favourite_ad_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>'Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$ad_id = $getpost->ad_id;
				
				$fav_status = $this->user->AddRemoveFavourite($user_id,$ad_id);
				
				if($fav_status == 1){
					// insert
					$this->response(
						[
							"status" => TRUE,
							"is_favourite" => 1,
							// "message" => "Added in favourite list."
							"message" => "Ajouté dans la liste des favoris."
						] ,REST_Controller::HTTP_OK
						);
				}else if($fav_status == 2){
					// delete
					$this->response(
						[
							"status" => TRUE,
							"is_favourite" => 0,
							// "message" => "Removed from favourite list."
							"message" => 'Supprimé de la liste des favoris.'
						] ,REST_Controller::HTTP_OK
						);
				}else{
					// error
					$this->response(
						[
							"status" => TRUE,
							"is_favourite" => "",
							"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'un problème de serveur."
						] ,REST_Controller::HTTP_OK
						);
				}
			}
		}
	}
	
	public function my_favourite_ad_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>'Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$Ad_list = $this->user->GetFavouriteAdList($user_id);
				
				if($Ad_list){
					
					$new_ad_list = array();
					foreach($Ad_list as $ad_detail)
					{
						$ad_gallery = $this->user->GetAdGallery($ad_detail->id);
						$ad_documents = $this->user->GetAdDocumets($ad_detail->id);
						
						$new_ad_list[] = array(
											'ad_id' => $ad_detail->id,
											'user_id' => $ad_detail->user_id,
											'cat_id_1' => $ad_detail->cat_id_1,
											'cat_id_2' => $ad_detail->cat_id_2,
											'category_name' => $ad_detail->category_name,
											'sub_category_name' => $ad_detail->sub_category_name,
											'title' => $ad_detail->title,
											'description' => $ad_detail->description,
											'short_description' => $ad_detail->short_description,
											'location' => $ad_detail->location,
											'latitude' => $ad_detail->latitude,
											'longitude' => $ad_detail->longitude,
											'offer' => $ad_detail->offer,
											'created' => $ad_detail->created,
											'updated' => $ad_detail->updated,
											'is_verified' => $ad_detail->is_verified,
											'ad_gallery' => $ad_gallery,
											'ad_documents' => $ad_documents
										);
					}
					$this->response(
						[
							'pre_url' => base_url(),
							'Ad_list' => $new_ad_list,
							'status' => TRUE,
							'message' => 'OK'
						] ,REST_Controller::HTTP_OK
						);
				}else{
					$this->response(
						[
							'pre_url' => base_url(),
							'Ad_list' => $Ad_list,
							'status' => TRUE,
							'message' => 'OK'
						] ,REST_Controller::HTTP_OK
						);
				}
			}
		}
	}
	
	// for service provider only
	public function my_ad_list_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$user_info = $this->user->GetUserById($user_id);
				
				if($user_info->type == 1)
				{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Vous n'êtes pas autorisé à accéder à ces informations."
							] ,REST_Controller::HTTP_OK
							);
				}
				else
				{
					$my_ads = $this->user->GetAdByUser($user_id);
				
					$new_ad_list = array();
					foreach($my_ads as $val)
					{
						$ad_gallery = $this->user->GetAdGallery($val->id);
						$new_ad_list[] = array(
											'ad_id' => $val->id,
											'user_id' => $val->user_id,
											'cat_id_1' => $val->cat_id_1,
											'cat_id_2' => $val->cat_id_2,
											'category_name' => $val->category_name,
											'sub_category_name' => $val->sub_category_name,
											'title' => $val->title,
											'description' => $val->description,
											'short_description' => $val->short_description,
											'location' => $val->location,
											'latitude' => $val->latitude,
											'longitude' => $val->longitude,
											'offer' => $val->offer,
											'created' => $val->created,
											'updated' => $val->updated,
											'is_verified' => $val->is_verified,
											'pre_path' => base_url(),
											'ad_gallery' => $ad_gallery
										);
					}
					
					if($new_ad_list){
						
						$this->response(
								[
									'my_ad' => $new_ad_list,
									'status' => TRUE,
									'message' => 'OK'
								] ,REST_Controller::HTTP_OK
								);
						
						
					}else{
						$this->response(
								[
									'my_ad' => '',
									'status' => TRUE,
									"message" => "Aucune annonce trouvée."
								] ,REST_Controller::HTTP_OK
								);
					}
				}
			}
		}
	}

	public function admin_contact_info_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);				
				
				$contact_info = $this->user->GetAdminContactInfo();
			
				$this->response(
						[
							'contact_info' => $contact_info,
							'status' => TRUE,
							'message' => 'OK'
						] ,REST_Controller::HTTP_OK
						);
			}
		}
	}

	public function faq_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);				
				
				$faq = $this->user->GetAllFaq();
			
				$this->response(
						[
							'faq' => $faq,
							'status' => TRUE,
							'message' => 'OK'
						] ,REST_Controller::HTTP_OK
						);
			}
		}
	}
	
	
	public function All_promotion_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);				
				
				$all_promotion = $this->user->GetAllPromotion();
			
				$this->response(
						[
							'pre_url' => WELI_WEB_URL,
							'all_promotion' => $all_promotion,
							'status' => TRUE,
							'message' => 'OK'
						] ,REST_Controller::HTTP_OK
						);
			}
		}
	}
	
	public function my_subscription_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);				
				
				$subs = $this->user->GetSubscriptionStatus($user_id);
				if(!$subs){
					$user_status = array(
											'subscription_plan' => '',
											'status' => '',
											'end_date' => '',
											'action' => ''
										);
					$this->response(
							[
								'subscription_status' => $user_status
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$s_date = $subs->subscription_date;
					$e_date = $subs->expire_date;
					
					if($e_date > date("Y-m-d H:i:s")){
						$subscription = '5 € / mois';
						$status = 'Active';
						$end_date = $e_date;
						$action = 'Cancel';
					}else{
						$subscription = '5 € / mois';
						$status = 'Expired';
						$end_date = $e_date;
						$action = 'Reactivate';
					}
					
					$user_status = array(
											'subscription_plan' => $subscription,
											'status' => $status,
											'end_date' => $end_date,
											'action' => $action
										);
					$this->response(
							[
								'subscription_status' => $user_status
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function cancel_subscription_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);				
				
				$res = $this->user->CancelSubscriptionStatus($user_id);
				if($res)
				{
					$subs = $this->user->GetSubscriptionStatus($user_id);
					if(!$subs){
						$user_status = array(
												'subscription_plan' => '',
												'status' => '',
												'end_date' => '',
												'action' => ''
											);
						$this->response(
								[
									'subscription_status' => $user_status
								] ,REST_Controller::HTTP_OK
								);
					}else{
						$s_date = $subs->subscription_date;
						$e_date = $subs->expire_date;
						
						if($e_date > date("Y-m-d H:i:s")){
							$subscription = '5 € / mois';
							$status = 'Active';
							$end_date = $e_date;
							$action = 'Cancel';
						}else{
							$subscription = '5 € / mois';
							$status = 'Expired';
							$end_date = $e_date;
							$action = 'Reactivate';
						}
						
						$user_status = array(
												'subscription_plan' => $subscription,
												'status' => $status,
												'end_date' => $end_date,
												'action' => $action
											);
						$this->response(
								[
									'subscription_status' => $user_status
								] ,REST_Controller::HTTP_OK
								);
					}
				
				}
			}
		}
	}
	
	public function product_list_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$products = $this->user->allDigitalProducts();
				if(count($products)> 0)
				{
					$this->response(
						[
							'pre_url' => WELI_WEB_URL,
							'product_list' => $products,
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
						);
				}
				else
				{
					$this->response(
						[
							'product_list' => '',
							'status' => FALSE,
							'message' => "il n'y a pas de produit."
						] ,REST_Controller::HTTP_OK
						);
				}

			}
		}
	}

	public function product_detail_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{

				$getpost = json_decode(file_get_contents('php://input'));
				$product_id = $getpost->product_id;

				$product = $this->user->GetDigitalProductDetail($product_id);
				if($product)
				{
					$this->response(
						[
							'pre_url' => WELI_WEB_URL,
							'product_detail' => $product,
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
						);
				}
				else
				{
					$this->response(
						[
							'product_detail' => '',
							'status' => FALSE,
							'message' => "Aucun détail sur le produit n'a été trouvé."
						] ,REST_Controller::HTTP_OK
						);
				}
			}
		}
	}

	public function add_to_cart_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$user_id = $this->input->get_request_header('user-id', TRUE);				
				$product_id = $getpost->product_id;

				// remove all cart data if their end_date not exist
				$res_0 = $this->user->RemoveCartDetailByEndDate();
				if($res_0)
				{
					// Check if user already added product or not
					$res_1 = $this->user->CheckProductInCart($user_id,$product_id);
					if($res_1 > 0)
					{
						$this->response(
							[
								'status' => FALSE,
								'message' => "Produit déjà disponible dans le panier."
							] ,REST_Controller::HTTP_OK
							);
					}
					else
					{
						$dataArray = array(
											'user_id' => $user_id,
											'product_id' => $product_id,
											'create_date' => date("Y-m-d H:i:s"),
											'end_date' => date("Y-m-d H:i:s", strtotime("+1 hour", strtotime(date("Y-m-d H:i:s")))),
										  );
						$res_2 = $this->user->AddToCart($dataArray);
						if($res_2)
						{
							$this->response(
								[
									'status' => TRUE,
									'message' => "Produit ajouté dans le panier."
								] ,REST_Controller::HTTP_OK
								);
						}
						else
						{
							$this->response(
								[
									'status' => FALSE,
									'message' => "Désolé ! Nous ne sommes pas en mesure de traiter votre demande."
								] ,REST_Controller::HTTP_OK
								);
						}
					}
				}

			}
		}
	}
	
	public function my_cart_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				$carts = $this->user->MyCartProducts($user_id);
				if(count($carts)> 0)
				{
					$this->response(
						[
							'pre_url' => WELI_WEB_URL,
							'my_cart' => $carts,
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
						);
				}
				else
				{
					$this->response(
						[
							'my_cart' => '',
							'status' => FALSE,
							'message' => "Le chariot est vide."
						] ,REST_Controller::HTTP_OK
						);
				}

			}
		}
	}

	public function my_order_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				$orders = $this->user->MyOrders($user_id);

				$new_orders = array();
				foreach($orders as $val)
				{
					$order_files = $this->user->GetOrdersFile($val->product_id);
					
					$new_orders[] = array(
										'id' => $val->id,
										'order_id' => $val->order_id,
										'txn_id' => $val->txn_id,
										'user_id' => $val->user_id,
										'product_id' => $val->product_id,
										'amount' => $val->amount,
										'payment_bank' => $val->payment_bank,
										'create_date' => $val->create_date,
										'product_name' => $val->product_name,
										'product_image' => $val->product_image,
										'product_price' => $val->product_price,
										'product_description' => $val->product_description,
										'order_files' => $order_files
									);
				}

				if(count($orders)> 0)
				{
					$this->response(
						[
							'pre_url' => WELI_WEB_URL,
							'order_list' => $new_orders,
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
						);
				}
				else
				{
					$this->response(
						[
							'pre_url' => WELI_WEB_URL,
							'order_list' => '',
							'status' => FALSE,
							'message' => "Aucun enregistrement trouvé."
						] ,REST_Controller::HTTP_OK
						);
				}

			}
		}
	}

	public function my_research_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				$research_list = $this->user->MyResearch($user_id);
				if(count($research_list)> 0)
				{
					$this->response(
						[
							'research_list' => $research_list,
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
						);
				}
				else
				{
					$this->response(
						[
							'research_list' => '',
							'status' => FALSE,
							'message' => "Aucun enregistrement trouvé."
						] ,REST_Controller::HTTP_OK
						);
				}

			}
		}
	}

	public function my_notification_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				$notification_list = $this->user->MyNotification($user_id);
				if(count($notification_list)> 0)
				{
					$this->user->ChangeUserNotificationStatus($user_id);
					$this->response(
						[
							'notification_list' => $notification_list,
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
						);
				}
				else
				{
					$this->response(
						[
							'notification_list' => '',
							'status' => FALSE,
							'message' => "Aucun enregistrement trouvé."
						] ,REST_Controller::HTTP_OK
						);
				}

			}
		}
	}

	public function notification_count_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				$notification_count = $this->user->MyUnreadNotificationCount($user_id);
				
				$this->response(
					[
						'notification_count' => $notification_count,
						'status' => TRUE,
						'message' => "OK"
					] ,REST_Controller::HTTP_OK
					);
			}
		}
	}
	
	public function notification_detail_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				$notification_id = $getpost->notification_id;
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				$notification_detail = $this->user->NotificationDetail($user_id,$notification_id);
				
				$this->response(
					[
						'notification_detail' => $notification_detail,
						'status' => TRUE,
						'message' => "OK"
					] ,REST_Controller::HTTP_OK
					);
			}
		}
	}

	public function ad_delete_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				$ad_id = $getpost->ad_id;
				$user_id = $this->input->get_request_header('user-id', TRUE);				

				// gallery delete
					$gallery_del = $this->user->GetAdGallery($ad_id);
					if(count($gallery_del) > 0){
						foreach ($gallery_del as $value) 
						{
							$this->user->DeleteAdGallery($ad_id,$value->image_id);
							if(file_exists($value->image_path)) 
							{   
								chmod($value->image_path, 0777);
								unlink($value->image_path);                         
							}
						}
					}
				// document delete
					$doc_del = $this->user->GetAdDocumets($ad_id);
					if(count($doc_del) > 0){
						foreach ($doc_del as $value) 
						{
							$this->user->DeleteAdDocument($ad_id,$value->id);
							if(file_exists($value->doc_path)) 
							{   
								chmod($value->doc_path, 0777);
								unlink($value->doc_path);                         
							}
						}
					}
				// ad detail delete
					$this->user->DeleteAdDetails($ad_id);
				// ad favourite delete
					$this->user->DeleteAdAllFavourite($ad_id);

				$res = $this->user->DeleteAd($user_id,$ad_id);
				
				if($res)
				{
					$this->response(
						[
							'status' => TRUE,
							'message' => "Votre annonce a été supprimée avec succès."
						] ,REST_Controller::HTTP_OK
					);
				}
				else
				{
					$this->response(
						[
							'status' => FALSE,
							'message' => "Désolé ! Nous ne sommes pas en mesure de traiter votre demande."
						] ,REST_Controller::HTTP_OK
					);
				}
			}
		}
	}

	public function ad_image_delete_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$ad_id = $getpost->ad_id;
				$image_id = $getpost->image_id;
				
				$ad_gal = $this->user->GetAdGalleryByImage($ad_id,$image_id);
				if(file_exists($ad_gal->image_path)) 
				{   
					chmod($ad_gal->image_path, 0777);
					unlink($ad_gal->image_path);
					$del = $this->user->DeleteAdGallery($ad_id,$image_id);
					if($del){
						$this->response(
							[
								'status' => TRUE,
								'message' => "Image publicitaire supprimée. "
							] ,REST_Controller::HTTP_OK
						);
					}else{
						$this->response(
							[
								'status' => FALSE,
								'message' => "Image publicitaire non supprimée."
							] ,REST_Controller::HTTP_OK
						);
					}                   
				}
			}
		}
	}

	public function ad_document_delete_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$ad_id = $getpost->ad_id;
				$document_id = $getpost->document_id;
				
				$ad_doc = $this->user->GetAdDocumentByDocument($ad_id,$document_id);
				if(file_exists($ad_doc->doc_path)) 
				{   
					chmod($ad_doc->doc_path, 0777);
					unlink($ad_doc->doc_path);
					$del = $this->user->DeleteAdDocument($ad_id,$document_id);
					if($del){
						$this->response(
							[
								'status' => TRUE,
								'message' => "Document publicitaire supprimée. "
							] ,REST_Controller::HTTP_OK
						);
					}else{
						$this->response(
							[
								'status' => FALSE,
								'message' => "Document publicitaire non supprimée."
							] ,REST_Controller::HTTP_OK
						);
					}                   
				}
			}
		}
	}

	public function ad_update_post()
	{
		if(!is_dir("./assets/uplods/ad_documents")){ 
			mkdir("./assets/uplods/ad_documents", 0777, true);
		}
		
		if(!is_dir("./assets/uplods/ad_gallery")){ 
			mkdir("./assets/uplods/ad_gallery", 0777, true);
		}
		
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				// checking advertiser subscription plan START
				$check_subscription = $this->check_subscription();
				if($check_subscription['response'] == 0)
				{
					$this->response(
							[
								'status' => FALSE,
								'message' => $check_subscription['message']
							] ,REST_Controller::HTTP_OK
							);
				}
				else
				{
					
					$ad_id = $_POST['ad_id'];
					$category_id = $_POST['category_id'];
					$sub_category_id = $_POST['sub_category_id'];
					
					$title = $_POST['title'];
					$description = $_POST['description'];
					$short_description = $_POST['short_description'];
					// $pricing_title = $_POST['pricing_title'];
					// $pricing_cost = $_POST['pricing_cost'];
					$location = $_POST['location'];
					$latitude = $_POST['latitude'];
					$longitude = $_POST['longitude'];
					$offer = $_POST['offer'];
					
					// print_r($_POST); print_r($_FILES);
					// die;
					
					$dataArray = array(
										'user_id' => $user_id,
										'cat_id_1' => $category_id,
										'cat_id_2' => $sub_category_id,
										'title' => $title,
										'description' => $description,
										'short_description' => $short_description,
										'location' => $location,
										'latitude' => $latitude,
										'longitude' => $longitude,
										'offer' => $offer,
										'show_till' => $check_subscription['expire_date'],
										// 'created' => date("Y-m-d H:i:s"),
										'updated' => date("Y-m-d H:i:s")
									  );
					
					$last_id = $this->user->ad_update($ad_id,$dataArray);
					if($last_id > 0)
					{
						// Gallery upload starts
							if(isset($_FILES['ad_gallery']))
							{
								if($_FILES['ad_gallery']['name'][0]){
									$is_gallery = count($_FILES['ad_gallery']['name']);
								}else{
									$is_gallery = 0;
								}
								if($is_gallery > 0)
								{
									$ad_gallery = $_FILES['ad_gallery']['name'];
									$ad_gallery_count = count($ad_gallery);
									for ($pi = 0; $pi < $ad_gallery_count; $pi++) 
									{
										$_FILES['file']['name'] = $_FILES['ad_gallery']['name'][$pi];
										$_FILES['file']['type'] = $_FILES['ad_gallery']['type'][$pi];
										$_FILES['file']['tmp_name'] = $_FILES['ad_gallery']['tmp_name'][$pi];
										$_FILES['file']['error'] = $_FILES['ad_gallery']['error'][$pi];
										$_FILES['file']['size'] = $_FILES['ad_gallery']['size'][$pi];
										
										$config = array(
													'upload_path' => "./assets/uplods/ad_gallery",
													'allowed_types' => "*",
													'overwrite' => TRUE,
													'encrypt_name' => TRUE,
													// 'max_size' => '3072000',
													'file_name' => time().$_FILES['ad_gallery']['name'][$pi]
													);
										
										$this->load->library('upload',$config);
										$this->upload->initialize($config);
										
										if (!$this->upload->do_upload('file'))
										{
											echo json_encode(array('response' => 0, 'msg' => $this->upload->display_errors()));
											exit;
										}
										else
										{
											$pimage = $this->upload->data();

											$dataArray_1 = array(
																'image_path' => "assets/uplods/ad_gallery/".$pimage['file_name'],
																'ad_id' => $last_id,
																'user_id' => $user_id,
																'image_name' => $pimage['file_name'],
																'cat_id_1' => $category_id,
																'cat_id_2' => $sub_category_id,
																'created' => date("Y-m-d H:i:s"),
																'updated' => date("Y-m-d H:i:s")
															);

											$addedORnot = $this->user->UploadAdGallery($dataArray_1);
										}
									}
								}
							}
						// Gallery upload ends
						
						// Documents upload starts
							if(isset($_FILES['ad_documents']))
							{
								if($_FILES['ad_documents']['name'][0]){
									$is_document = count($_FILES['ad_documents']['name']);
								}else{
									$is_document = 0;
								}
								if($is_document > 0)
								{
									$ad_documents = $_FILES['ad_documents']['name'];
									$ad_documents_count = count($ad_documents);
									for ($pi = 0; $pi < $ad_documents_count; $pi++) 
									{
										$_FILES['file']['name'] = $_FILES['ad_documents']['name'][$pi];
										$_FILES['file']['type'] = $_FILES['ad_documents']['type'][$pi];
										$_FILES['file']['tmp_name'] = $_FILES['ad_documents']['tmp_name'][$pi];
										$_FILES['file']['error'] = $_FILES['ad_documents']['error'][$pi];
										$_FILES['file']['size'] = $_FILES['ad_documents']['size'][$pi];
										
										$config = array(
													'upload_path' => "./assets/uplods/ad_documents",
													'allowed_types' => "*",
													'overwrite' => TRUE,
													'encrypt_name' => TRUE,
													// 'max_size' => '3072000',
													'file_name' => time().$_FILES['ad_documents']['name'][$pi]
													);
										
										$this->load->library('upload',$config);
										$this->upload->initialize($config);
										
										if (!$this->upload->do_upload('file'))
										{
											echo json_encode(array('response' => 0, 'msg' => $this->upload->display_errors()));
											exit;
										}
										else
										{
											$pimage = $this->upload->data();

											$dataArray_1 = array(
																'ad_id' => $last_id,
																'user_id' => $user_id,
																'doc_path' => "assets/uplods/ad_documents/".$pimage['file_name'],
																'doc_title' => $_POST['doc_title'][$pi],
																// 'doc_title' => $pi,
																'doc_name' => $pimage['file_name'],
																'cat_id_1' => $category_id,
																'cat_id_2' => $sub_category_id,
																'created' => date("Y-m-d H:i:s"),
																'updated' => date("Y-m-d H:i:s")
															);

											$addedORnot = $this->user->UploadAdDocuments($dataArray_1);
										}
									}
								}
							}
						// Documents upload ends
						
						// ad detail delete
						$this->user->DeleteAdDetails($ad_id);

						// Dynamic form data submission starts
							$post_count = count($_POST)-11; $pcount = 0;
							if($post_count > 0)
							{
								foreach($_POST as $key=>$val)
								{
									if(
										$key != 'category_id' &&
										$key != 'sub_category_id' &&
										$key != 'title' &&
										$key != 'description' &&
										$key != 'short_description' &&
										$key != 'location' &&
										$key != 'latitude' &&
										$key != 'longitude' &&
										$key != 'offer' &&
										$key != 'doc_title'
									  )
									{
										$newArray = array(
															'cat_1' => $category_id,
															'cat_2' => $sub_category_id,
															'ad_id' => $last_id,
															'meta_key' => str_replace('_', ' ', $key),
															'meta_value' => $val,
															'created' => date("Y-m-d H:i:s"),
															'updated' => date("Y-m-d H:i:s")
														 );
														 
										$adres = $this->user->ad_detail_submit($newArray);
										if($adres){
											$pcount = $pcount+1;
											
											if($pcount == $post_count)
											{
												$this->response(
													[
														'status' => TRUE,
														"message" => "Annonce mise à jour avec succès."
													] ,REST_Controller::HTTP_OK
												);
											}
										}								
									}
								}
							}
							else
							{
								$this->response(
											[
												'status' => TRUE,
												"message" => "Annonce soumise avec succès."
											] ,REST_Controller::HTTP_OK
										);
							}
						// Dynamic form data submission ends
					}
					else
					{
						$this->response(
								[
									'status' => FALSE,
									"message" => "Une erreur s'est produite lors de la soumission d'informations publicitaires."
								] ,REST_Controller::HTTP_OK
								);
					}
				}
			}
		}
	}

	public function ad_counter_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$ad_id = $getpost->ad_id;
				$counter_type = $getpost->counter_type; 
				// ( $counter_type = view_count / email_count / phone_count / favourite_count / chat_count )
				
				$added = $this->user->AdCounter($ad_id,$counter_type);
				if($added){
					$this->response(
						[
							'status' => TRUE,
							'message' => "OK"
						] ,REST_Controller::HTTP_OK
					);
				}else{
					$this->response(
						[
							'status' => FALSE,
							'message' => "ECHOUÉ"
						] ,REST_Controller::HTTP_OK
					);
				}                   
			}
		}
	}

	public function ad_counter_list_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$ad_id = $getpost->ad_id;
				
				$lists = $this->user->AdCounterList($ad_id);
				$this->response(
					[
						'status' => TRUE,
						'ad_count_list' => $lists
					] ,REST_Controller::HTTP_OK
				);
			}
		}
	}
	
	public function top_search_keyup_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$search_keyword = $getpost->search_keyword;
				$latitude = $getpost->latitude;
				$longitude = $getpost->longitude;
				
				$cat_1_lists = $this->user->TopSearchKeyup($search_keyword,$latitude,$longitude,'tbl_category_1');
				$cat_2_lists = $this->user->TopSearchKeyup($search_keyword,$latitude,$longitude,'tbl_category_2');
				$ad_lists = $this->user->TopSearchKeyup($search_keyword,$latitude,$longitude,'tbl_ad');

				$search_list = array_merge($cat_1_lists,$cat_2_lists,$ad_lists);
				// print_r($search_list); die;
				
				$this->response(
					[
						'status' => TRUE,
						'search_list' => $search_list
					] ,REST_Controller::HTTP_OK
				);
			}
		}
	}

	public function top_search_ad_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$category_id = $getpost->category_id;
				$sub_category_id = $getpost->sub_category_id;
				$ad_id = $getpost->ad_id;
				$identity = $getpost->identity;
				$latitude = $getpost->latitude;
				$longitude = $getpost->longitude;
				
				$ad_list = $this->user->GetAdByTopSearch($category_id,$sub_category_id,$ad_id,$identity,$latitude,$longitude);
				
				$new_ad_list = array();
				foreach($ad_list as $val)
				{
					$ad_gallery = $this->user->GetAdGallery($val->id);
					// $ad_documents = $this->user->GetAdDocumets($val->id);
					// $ad_user = $this->user->GetUserById($val->user_id);
					// $ad_criteria = $this->user->GetAdCriteria($val->id);
					
					$new_ad_list[] = array(
										'ad_id' => $val->id,
										'user_id' => $val->user_id,
										'cat_id_1' => $val->cat_id_1,
										'cat_id_2' => $val->cat_id_2,
										'category_name' => $val->category_name,
										'sub_category_name' => $val->sub_category_name,
										'title' => $val->title,
										'description' => $val->description,
										'short_description' => $val->short_description,
										'location' => $val->location,
										'latitude' => $val->latitude,
										'longitude' => $val->longitude,
										'offer' => $val->offer,
										'created' => $val->created,
										'updated' => $val->updated,
										'is_verified' => $val->is_verified,
										'is_favourite' => $val->is_favourite,
										'pre_path' => base_url(),
										// 'ad_criteria' => $ad_criteria,
										// 'ad_documents' => $ad_documents,
										'ad_gallery' => $ad_gallery
										// 'ad_user' => $ad_user
									);
				}
				
				// print_r($new_ad_list); die;
				
				if($new_ad_list){
					$this->response(
							[
								'ad_list' => $new_ad_list,
								'status' => TRUE,
								'message' => 'OK'
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'ad_list' => '',
								'status' => FALSE,
								"message" => "Aucune annonce trouvée."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
