<?php
defined('BASEPATH') OR exit('No direct script access allowed');

require APPPATH . 'libraries/REST_Controller.php';
     
class Auth_user extends REST_Controller {

	function __construct() 
	{
		header('Content-type: application/json');
        header("Access-Control-Allow-Origin: *");
        header("Access-Control-Allow-Methods: GET, POST");
        header("Access-Control-Allow-Headers: Content-Type, Content-Length, Accept-Encoding, x-api-key , user-id , token");
		
        parent::__construct();
		$this->load->model('User_model','user');
    }
	
    var $auth_key = "safesystem@2020";

	public function index_get()
	{
		$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
	}
	
	public function index_post()
	{
		$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
	}
	
    public function check_auth_key()
	{
        $auth_key  = $this->input->get_request_header('x-api-key', TRUE);
        if($auth_key == $this->auth_key){
            return true;
        }else{
            return false;
        }
    }
	
	public function check_auth_token()
    {
        $users_id = $this->input->get_request_header('user-id', TRUE);
        $token = $this->input->get_request_header('token', TRUE);
		
        $q = $this->db->select('expire_time')
						->from('tbl_users_authentication')
						->where('user_id',$users_id)
						->where('token',$token)
						->get()
						->row();
        if($q == "")
		{
			return array('response' => 0, 'status' => FALSE, 'message' => 'Accès non autorisé.');			
        } 
		else 
		{
            $today_date = date("Y-m-d H:i:s"); 
            if($q->expire_time < $today_date)
			{
				return array('response' => 1, 'status' => FALSE, 'message' => 'Votre session est terminée.');					
            } 
			else 
			{
				$login_time = date("Y-m-d H:i:s");
				$expired_time = date("Y-m-d H:i:s", strtotime('+12 hours'));
				
				$res_2 = $this->user->UserAuthInfo($users_id,$token,$login_time,$expired_time);
				
				return array('response' => 2, 'status' => TRUE, 'message' => 'OK');					
            }
        }
    }
	
	public function fcm_notification($sender_id,$reciever_id,$title,$body,$identity)
	{
		$uinfo = $this->user->GetUserDeviceTokenInfo($reciever_id);
		// Sending Notification
		if (!empty($uinfo->token))
		{
		  $fields = array(
			  'to' => $uinfo->token,
			  'notification' => array(
						  "title" => $title,
						  "body" => $body,
						  "icon" => "assets/weli_logo.png",
						  "sound" => "mySound",
						  "color" => "#f4d890",
						  "click_action" => "FCM_PLUGIN_ACTIVITY"
						  ),
				'data' => array(
				"title" => $title,
				"body" => $body,
				"sender_id" => $sender_id,
				"reciever_id" => $reciever_id,
				"noti_identity" => $identity
				)
		  );
		  
		  $fields = json_encode ( $fields );
		  
		  $headers = array (
			  'Authorization: key='._FBKEY,
			  'Content-Type: application/json'
		  );
		  $ch = curl_init ();
		  curl_setopt ( $ch, CURLOPT_URL, _FBAPI);
		  curl_setopt ( $ch, CURLOPT_POST, true );
		  curl_setopt ( $ch, CURLOPT_HTTPHEADER, $headers );
		  curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, true );
		  curl_setopt ( $ch, CURLOPT_POSTFIELDS, $fields );
		  curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
		  $result = curl_exec ( $ch );
		  curl_close ( $ch );
		}
	}

	public function registration_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST')
		{
			$this->response(
							[
								'status' => FALSE,
								'message' => 'Méthode non autorisée.'
							] ,REST_Controller::HTTP_OK
							);
		} 
		else 
		{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
				
				$first_name = $getpost->first_name;
				$last_name = $getpost->last_name;
		        $email = $getpost->email;
		        $password = $getpost->password;
				if(isset($getpost->platform)){
					$platform = $getpost->platform;
				}else{
					$platform = 'app';
				}
		        
				if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{ 
					// check email existance
					$res_0 = $this->user->CheckExistance($email);
					if($res_0 > 0){
						
						$user_info = $this->user->GetUserData($email,'email');
						
						$this->response(
									[
										'user_info' => '',
										'status' => FALSE,
										"message" => "Le numéro d'identification du courrier électronique existe déjà."
									] ,REST_Controller::HTTP_OK
								); 
					}else{
						
						$DataArray = array(
											'first_name' => $first_name,
											'last_name	' => $last_name,
											'email' => $email,
											'password' => md5($password),
											'phone_no' => '',
											'platform' => $platform,
											'created' => date("Y-m-d H:i:s"),
											'updated' => date("Y-m-d H:i:s")
										  );
						
						$res_0 = $this->user->AddUser($DataArray);
						if($res_0 > 0){
							
							$user_info = $this->user->GetUserData($res_0,'id');
							// registration : OK
							$this->response(
									[
										'user_info' => $user_info,
										'status' => TRUE,
										"message" => "La demande d'enregistrement a été soumise avec succès."
									] ,REST_Controller::HTTP_OK
								); 
						}else{
							// registration : NOT OK
							$this->response(
									[
										'user_info' => '',
										'status' => FALSE,
										"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'une erreur de serveur."
									] ,REST_Controller::HTTP_OK
								); 
						}
						
					}
				}  
				else 
				{ 
					// email format checking : not ok
					$this->response(
								[
									'status' => FALSE,
									"message" => "Le format du courrier électronique n'est pas valide."
								] ,REST_Controller::HTTP_OK
								); 
				} 
			}
		}
	}
	
	public function login_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST')
		{
			$this->response(
							[
								'status' => FALSE,
								'message' => 'Méthode non autorisée.'
							] ,REST_Controller::HTTP_OK
							);
		} 
		else 
		{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
		        $email = $getpost->email;
				$password = $getpost->password;
		        $device_token = $getpost->device_token;
				
				if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{ 
					// check email existance
					$res_0 = $this->user->CheckExistance($email);
					if($res_0 == 0){
						$this->response(
									[
										'status' => FALSE,
										"message" => "Le numéro d'identification du courrier électronique n'existe pas."
									] ,REST_Controller::HTTP_OK
								); 
					}else{
						// get user login details
						$res_1 = $this->user->GetUserData($email,'email');
						
						if($res_1->is_email_verify == 0){
							$this->response(
										[
											'user_info' => '',
											'status' => FALSE,
											"message" => "Veuillez d'abord vérifier votre adresse électronique."
										] ,REST_Controller::HTTP_OK
									);
						}else if($res_1->is_account_verify == 0){
							$this->response(
										[
											'user_info' => '',
											'status' => FALSE,
											"message" => "Votre compte n'est pas encore activé."
										] ,REST_Controller::HTTP_OK
									);
						}else{
							if(strcmp(md5($password),$res_1->password) == 0){
							
								$token = crypt(substr( md5(rand()), 0, 7),substr( md5(rand()), 0, 7));
								$login_time = date("Y-m-d H:i:s");
								$expired_time = date("Y-m-d H:i:s", strtotime('+12 hours'));
																
								// Insert OR update user authentication details
								$res_2 = $this->user->UserAuthInfo($res_1->id,$token,$login_time,$expired_time);
								$this->user->UserDeviceTokenUpdate($res_1->id,$device_token);
								
								if($res_2){
									$this->response(
										[
											'pre_url' => base_url(),
											'user_info' => $res_1,
											'user_id' => $res_1->id,
											'token' => $token,
											'status' => TRUE,
											"message" => "Connexion réussie."
										] ,REST_Controller::HTTP_OK
									);
								}else{
									$this->response(
										[
											'status' => FALSE,
											"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'un problème de serveur."
										] ,REST_Controller::HTTP_OK
									);
								}
								
							}else{
								$this->response(
										[
											'status' => FALSE,
											"message" => "Le mot de passe est incorrect."
										] ,REST_Controller::HTTP_OK
									);
							}
						}
					}
				}  
				else 
				{ 
					// email format checking : not ok
					$this->response(
								[
									'status' => FALSE,
									"message" => "Format de courrier électronique non valide."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function logout_get()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'GET'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$users_id = $this->input->get_request_header('user-id', TRUE);
				$token = $this->input->get_request_header('token', TRUE);
				
				$res_1 = $this->user->LogoutMe($users_id,$token);
				if($res_1){
					$this->response(
							[
								'status' => TRUE,
								"message" => "Déconnexion réussie."
							] ,REST_Controller::HTTP_OK
							);
				}else{
					$this->response(
							[
								'status' => FALSE,
								"message" => "Erreur de déconnexion."
							] ,REST_Controller::HTTP_OK
							);
				}
			}
		}
	}
	
	public function forgotpassword_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$email = $getpost->email;
				
				if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{ 
					// check email existance
					$res_0 = $this->user->CheckExistance($email);
					if($res_0 == 0){
						$this->response(
									[
										'status' => FALSE,
										"message" => "Le numéro d'identification du courrier électronique n'existe pas."
									] ,REST_Controller::HTTP_OK
								); 
					}else{
						// get user login details
						$res_1 = $this->user->GetUserData($email,'email');
						
						if($res_1->is_email_verify == 0){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											"message" => "Veuillez d'abord vérifier votre adresse électronique."
										] ,REST_Controller::HTTP_OK
									);
						}else if($res_1->is_account_verify == 0){
							$this->response(
										[
											'user_info' => $res_1,
											'status' => FALSE,
											"message" => "Votre compte n'est pas encore activé."
										] ,REST_Controller::HTTP_OK
									);
						}else{
							// send user account password reset link
							$base64_userid = base64_encode($res_1->id);
							$url = BASE_URL().'action/forgotpassword?uid='.$base64_userid;
							// print_r($url); die;
							
							$this->user->ResetPasswordStatus($res_1->id,1);
							
							$this->load->library('My_PHPMailer');
					
							$body = '<head></head>';
							$body .= '<body class="clean-body" style="margin: 0;padding: 0;-webkit-text-size-adjust: 100%;">';
							$body .= '<table class="nl-container" style="border-collapse: collapse;table-layout: fixed;border-spacing: 0;mso-table-lspace: 0pt;mso-table-rspace: 0pt;vertical-align: top;min-width: 320px;Margin: 0 auto;width: 100%" cellpadding="0" cellspacing="0">';
							$body .= '<tbody><tr style="vertical-align: top"><td style="word-break: break-word;border-collapse: collapse !important;vertical-align: top"><div style="background-color:transparent;">';
							$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
							$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
							$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
							$body .= '<div style="background-color: transparent; width: 100% !important;">';
							$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:5px; padding-bottom:5px; padding-right: 0px; padding-left: 0px;">';
							$body .= '</div></div></div></div></div></div>';
							$body .= '<div style="background-color:transparent;">';
							$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
							$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
							$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
							$body .= '<div style="background-color: transparent; width: 100% !important;">';
							$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:20px; padding-bottom:15px; padding-right: 0px; padding-left: 0px;">';
							$body .= '<div class="">';
							$body .= '<div style="color:#555555;line-height:120%;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif; padding-right: 10px; padding-left: 10px; padding-top: 10px; padding-bottom: 10px;">';
							$body .= '<div style="font-size:12px;line-height:14px;color:#555555;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif;text-align:left;"><p style="margin: 0;font-size: 14px;line-height: 17px;text-align: center"><span style="font-size: 24px; line-height: 28px;"><strong>';
							// $body .= 'Your password reset link :';
							$body .= 'Votre lien de réinitialisation du mot de passe :';
							$body .= '</strong></span><br></p></div>';	
							$body .= '</div></div>';
							$body .= '<a href="'.$url.'" target="_new">'.$url.'</a>';
							$body .= '</div></div></div></div></div></div>';    
							$body .= '</td></tr></tbody></table></body></html>';
							
							$mail = new PHPMailer();
							$mail->IsSMTP();
							$mail->SMTPDebug = 1;
							$mail->SMTPAuth = true;
							$mail->SMTPSecure = 'ssl';
							$mail->Host = "mail.curzenncloud.fr";
							$mail->Port = 465; // or 587
							$mail->IsHTML(true);
							$mail->Username = "smtp.weli@curzenncloud.fr";
							$mail->Password = "N)kGea1KNxan";
							$mail->SetFrom('smtp.weli@curzenncloud.fr');
							$mail->Subject = "Mot de passe oublié - Safe System";
							$mail->Body = $body;
							$mail->AddAddress($email);

							if($mail->Send()){
								$this->response(
												[
													'status' => TRUE,
													// 'message' => 'Password reset link has been sent on your email address.'
													'message' => 'Un lien de réinitialisation du mot de passe a été envoyé sur votre adresse électronique.'
												] ,REST_Controller::HTTP_OK
												); 
							}else{
								$this->response(
												[
													'status' => FALSE,
													"message" => "Désolé ! Nous ne pouvons pas envoyer le lien de réinitialisation du mot de passe en raison d'une erreur de serveur."
												] ,REST_Controller::HTTP_OK
												); 
							}
						}
					}
				}  
				else 
				{ 
					// email format checking : not ok
					$this->response(
								[
									'status' => FALSE,
									"message" => "Format de courrier électronique non valide."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function verifyemail_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $getpost->user_id;
				$email = $getpost->email;
				
				if($email) 
				{ 
					if(filter_var($email, FILTER_VALIDATE_EMAIL)) 
					{
						$user_info = $this->user->GetUserData($user_id,'id');
						if($user_info->email == $email){
							
							if($user_info->is_email_verify == 1){
								$this->response(
										[
											'status' => TRUE,
											"message" => "Courriel déjà vérifié."
										] ,REST_Controller::HTTP_OK
										); 
							}else{
								
								$base64_userid = base64_encode($user_id);
								$url = BASE_URL().'action/emailverification?uid='.$base64_userid;
								// print_r($url); die;
								
								$this->load->library('My_PHPMailer');
						
								$body = '<head></head>';
								$body .= '<body class="clean-body" style="margin: 0;padding: 0;-webkit-text-size-adjust: 100%;background-color: #CCCCCC">';
								$body .= '<table class="nl-container" style="border-collapse: collapse;table-layout: fixed;border-spacing: 0;mso-table-lspace: 0pt;mso-table-rspace: 0pt;vertical-align: top;min-width: 320px;Margin: 0 auto;background-color: #CCCCCC;width: 100%" cellpadding="0" cellspacing="0">';
								$body .= '<tbody><tr style="vertical-align: top"><td style="word-break: break-word;border-collapse: collapse !important;vertical-align: top"><div style="background-color:transparent;">';
								$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
								$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
								$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
								$body .= '<div style="background-color: transparent; width: 100% !important;">';
								$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:5px; padding-bottom:5px; padding-right: 0px; padding-left: 0px;">';
								$body .= '</div></div></div></div></div></div>    ';
								$body .= '<div style="background-color:transparent;">';
								$body .= '<div style="Margin: 0 auto;min-width: 320px;max-width: 550px;overflow-wrap: break-word;word-wrap: break-word;word-break: break-word;background-color: #FFFFFF;" class="block-grid ">';
								$body .= '<div style="border-collapse: collapse;display: table;width: 100%;background-color:#FFFFFF;">';
								$body .= '<div class="col num12" style="min-width: 320px;max-width: 550px;display: table-cell;vertical-align: top;">';
								$body .= '<div style="background-color: transparent; width: 100% !important;">';
								$body .= '<div style="border-top: 0px solid transparent; border-left: 0px solid transparent; border-bottom: 0px solid transparent; border-right: 0px solid transparent; padding-top:20px; padding-bottom:15px; padding-right: 0px; padding-left: 0px;">';
								$body .= '<div class="">';
								$body .= '<div style="color:#555555;line-height:120%;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif; padding-right: 10px; padding-left: 10px; padding-top: 10px; padding-bottom: 10px;">';
								$body .= '<div style="font-size:12px;line-height:14px;color:#555555;font-family:Arial, `Helvetica Neue`, Helvetica, sans-serif;text-align:left;"><p style="margin: 0;font-size: 14px;line-height: 17px;text-align: center"><span style="font-size: 24px; line-height: 28px;"><strong>';
								// $body = 'Click on below button to verify your email address :';
								$body = 'Cliquez sur le lien ci-dessous pour vérifier votre adresse électronique :';
								$body .= '</strong></span><br></p></div>';	
								$body .= '</div></div>';
								$body .= '<a href="'.$url.'" target="_new">'.$url.'</a>';
								$body .= '</div></div></div></div></div></div>';    
								$body .= '</td></tr></tbody></table></body></html>';
								
								$mail = new PHPMailer();
								$mail->IsSMTP();
								$mail->SMTPDebug = 1;
								$mail->SMTPAuth = true;
								$mail->SMTPSecure = 'ssl';
								$mail->Host = "mail.curzenncloud.fr";
								$mail->Port = 465; // or 587
								$mail->IsHTML(true);
								$mail->Username = "smtp.weli@curzenncloud.fr";
								$mail->Password = "N)kGea1KNxan";
								$mail->SetFrom('smtp.weli@curzenncloud.fr');
								$mail->Subject = "Email Verification - Diaspora Interaction";
								// $mail->Subject = "Vérification des courriers électroniques - Weli";
								$mail->Body = $body;
								$mail->AddAddress($email);

								if($mail->Send()){
									$this->response(
													[
														'status' => TRUE,
														// 'message' => 'Email verification link has been sent on your email address.'
														'message' => 'Un lien de vérification a été envoyé sur votre adresse électronique.'
													] ,REST_Controller::HTTP_OK
													); 
								}else{
									$this->response(
													[
														'status' => FALSE,
														"message" => "Désolé ! Nous ne pouvons pas envoyer le lien de réinitialisation du mot de passe en raison d'une erreur de serveur."
													] ,REST_Controller::HTTP_OK
													); 
								}
								
							}
							
						}else{
							$this->response(
										[
											'status' => FALSE,
											"message" => "Correspondance des courriels."
										] ,REST_Controller::HTTP_OK
									);
						}
					}  
					else 
					{ 
						$this->response(
									[
										'status' => FALSE,
										"message" => "Format de courrier électronique non valide."
									] ,REST_Controller::HTTP_OK
									); 
					}
				}  
				else 
				{ 
					$this->response(
								[
									'status' => FALSE,
									"message" => "Adresse électronique requise."
								] ,REST_Controller::HTTP_OK
								); 
				}
			}
		}
	}
	
	public function check_account_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else
			{
				$getpost = json_decode(file_get_contents('php://input'));
								
				$user_id = $getpost->user_id;
				$user_info = $this->user->GetUserData($user_id,'id');
				if($user_info->is_account_verify == 1){
					$this->response(
									[
										'status' => TRUE,
										"message" => "Votre compte est vérifié."
									] ,REST_Controller::HTTP_OK
									);
				}else{
					$this->response(
									[
										'status' => FALSE,
										"message" => "Votre compte n'est toujours pas vérifié."
									] ,REST_Controller::HTTP_OK
									);
				}
			}
		}
	}
	
	public function update_password_post()
	{
		$method = $_SERVER['REQUEST_METHOD'];
		if($method != 'POST'){
			$this->response(
						[
							'status' => FALSE,
							'message' => 'Accès non autorisé.'
						] ,REST_Controller::HTTP_OK
						);
		}else{
			$check_auth_client = $this->check_auth_key();
			$check_auth_token = $this->check_auth_token();
   
			if($check_auth_client == false)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' =>' Erreur de clé d`authentification.'
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 0 || $check_auth_token['response'] == 1)
			{
				$this->response(
							[
								'status' => FALSE,
								'message' => $check_auth_token['message']
							] ,REST_Controller::HTTP_OK
							);
			}
			else if($check_auth_token['response'] == 2)
			{
				$getpost = json_decode(file_get_contents('php://input'));
							
				$user_id = $this->input->get_request_header('user-id', TRUE);
				
				$password = $getpost->password;
				$offer = $getpost->offer;
				
				$dataArray = array(
									'password' => md5($password),
									'offer' => $offer,
									'updated' => date("Y-m-d H:i:s")
								   );
				
				$res_0 = $this->user->UpdateUserData($user_id,$dataArray);
				if($res_0){
					$my_profile = $this->user->GetUserData($user_id,'id');
					$this->response(
								[
									'my_profile' => $my_profile,
									'status' => TRUE,
									"message" => "Profil mis à jour avec succès."
								] ,REST_Controller::HTTP_OK
								);
				}else{
					$my_profile = $this->user->GetUserData($user_id,'id');
					$this->response(
								[
									'my_profile' => $my_profile,
									'status' => FALSE,
									"message" => "Désolé ! Nous ne pouvons pas traiter votre demande en raison d'une erreur de serveur."
								] ,REST_Controller::HTTP_OK
								);
				}
			}
		}
	}






	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
