<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');


class Subscription extends CI_Controller{
    
    function  __construct(){
       
        parent::__construct();
		$this->load->model('User_model','user');
        $this->load->library('paypal_lib');
    }
     
	function payment()
	{				
		$gateway_type = $this->input->get('type'); // paypal OR stripe
		$user_id = $this->input->get('user_id');
		$plan_id = $this->input->get('plan_id');

		if($gateway_type == 'paypal')
		{
			$user_info = $this->user->GetUserById($user_id);
			$plan_info = $this->user->GetPremiumPlanById($plan_id);

			// calculating subscription amount according to the offer
			$plan_offer = $plan_info->offer;
			$plan_amount_in = $plan_info->amount_in;
			$plan_month = $plan_info->month;

			$total_amount = 0;
			if ($plan_offer == 0) {
				$total_amount = $plan_amount_in*$plan_month;
				// echo 1; echo '<br><br><br>';
			} else {
				if ($plan_info->offer_start <= date('Y-m-d') && $plan_info->offer_end >= date('Y-m-d')) {
					$total_amount_ = $plan_amount_in*$plan_month;
					$total_save = ($total_amount_)*($plan_offer)/100;
					$total_amount = $total_amount_ - $total_save;
					// echo 2; echo '<br><br><br>';
				} else {
					$total_amount = $plan_amount_in*$plan_month;
					// echo 3; echo '<br><br><br>';
				}
			}

			// print_r($total_amount); die;

			$returnURL = base_url().'subscription/success?mnt='.$plan_month;
			$cancelURL = base_url().'subscription/cancel';
			$notifyURL = base_url().'subscription/ipn';

			// Add fields to paypal form
			$this->paypal_lib->add_field('return', $returnURL);
			$this->paypal_lib->add_field('cancel_return', $cancelURL);
			$this->paypal_lib->add_field('notify_url', $notifyURL);
			$this->paypal_lib->add_field('item_name', $user_info->first_name.' '.$user_info->last_name);
			$this->paypal_lib->add_field('custom', $user_id);
			$this->paypal_lib->add_field('item_number', $user_info->email);
			$this->paypal_lib->add_field('amount', $total_amount);
			
			$this->paypal_lib->paypal_auto_form();
			
		}
		else
		{
			// stripe
			
		}

    }
	
    function success()
	{
		$paypalInfo = $_REQUEST;
		
		if(isset($paypalInfo['payer_email']))
		{
			$payer_email = $paypalInfo['payer_email'];
			$payer_id = $paypalInfo['payer_id'];
			$txn_id = $paypalInfo['txn_id'];
			$amount = $paypalInfo['payment_gross'];
			$currency = $paypalInfo['mc_currency'];
			$user_name = $paypalInfo['item_name'];
			$user_email = $paypalInfo['item_number'];
			$user_id = $paypalInfo['custom'];
			$payment_date = date("Y-m-d H:i:s");
		   
			$month = $_GET['mnt'];

			$dataArray_0 = array(
								'payer_email' => $payer_email,
								'payer_id' => $payer_id,
								'txn_id' => $txn_id,
								'amount' => $amount,
								'currency' => $currency,
								'user_name' => $user_name,
								'user_email' => $user_email,
								'user_id' => $user_id,
								'payment_bank' => 'paypal',
								'payment_date' => $payment_date
							  );
			
			$res_0 = $this->user->AddTransaction($dataArray_0);
			if($res_0)
			{
				$res_1 = $this->user->GetSubscriptionStatus($user_id);
				
				if($res_1)
				{
					$expiry_date = '';
					
					$exist_expire_date = $res_1->expire_date;
					if($exist_expire_date < date("Y-m-d H:i:s")){
						$expiry_date = date("Y-m-d H:i:s", strtotime("+".$month." month", strtotime(date("Y-m-d H:i:s"))));
					}else{
						$expiry_date = date("Y-m-d H:i:s", strtotime("+".$month." month", strtotime($exist_expire_date)));
					}
					
				}
				else
				{
					$expiry_date = date("Y-m-d H:i:s", strtotime("+".$month." month", strtotime(date("Y-m-d H:i:s"))));
				}
				
				$dataArray_1 = array(
								'user_id' => $user_id,
								'subscription_date' => date("Y-m-d H:i:s"),
								'expire_date' => $expiry_date
							  );
							  
				$res_2 = $this->user->AddUpdateSubscriptionStatus($dataArray_1);
				
				if($res_2)
				{
					echo json_encode(array('status'=> true, 'message'=> 'La transaction a été soumise avec succès.'));
					die;
				}
				else
				{
					echo json_encode(array('status'=> false, 'message'=> 'Erreur de soumission de la transaction.'));
					die;
				}
			}
			else
			{
				echo json_encode(array('status'=> false, 'message'=> 'Erreur de soumission de la transaction.'));
				die;
			}
		}
		else
		{
			echo json_encode(array('status'=> false, 'message'=> 'Le lien a expiré.'));
			die;
		}
				
    }
     
    function cancel()
	{
		echo json_encode(array('status'=> false, 'message'=> 'La transaction a été annulée.'));
		die;
	}
	
	function fail()
	{
		echo json_encode(array('status'=> false, 'message'=> "La transaction a échoué."));
		die;
	}

	function ipn()
	{
        // $paypalInfo = $this->input->post();
        $paypalInfo = $_REQUEST;
        				
        $data['user_id'] = $paypalInfo['custom'];
        $data['product_id']    = $paypalInfo["item_number"];
        $data['txn_id']    = $paypalInfo["txn_id"];
        $data['payment_gross'] = $paypalInfo["mc_gross"];
        $data['currency_code'] = $paypalInfo["mc_currency"];
        $data['payer_email'] = $paypalInfo["payer_email"];
        $data['payment_status']    = $paypalInfo["payment_status"];
 
        $paypalURL = $this->paypal_lib->paypal_url;        
        $result    = $this->paypal_lib->curlPost($paypalURL,$paypalInfo);
        
        //check whether the payment is verified
        if(preg_match("/VERIFIED/i",$result)){
            //insert the transaction data into the database
			return true;
        }
		
    }
	
	
}