<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class User_model extends CI_Model
{
	public function __construct()
	{
		date_default_timezone_set('Asia/Calcutta');
	}
	
	public function CheckExistance($email)
	{
		$this->db->where('email',$email);
		$this->db->from('tbl_users');
        $ret = $this->db->count_all_results();
		return $ret;
	}
	
	public function AddUser($dataArray)
	{
		$q1 = $this->db->insert('tbl_users', $dataArray);
		if($q1){
			$insert_id = $this->db->insert_id();
			return $insert_id;
		}else{
			return 0;
		}
	}
	
	public function GetUserData($emailORid,$remark)
	{
		$this->db->select("*");
		if($remark == 'email'){
			$this->db->where('email' ,$emailORid);
		}else{
			$this->db->where('id' ,$emailORid);
		}
		$query = $this->db->get('tbl_users');
		return $query->row();
	}
	
	public function UserAuthInfo($user_id,$token,$login_time,$expire_time)
	{
		$this->db->where('user_id',$user_id);
		$this->db->from('tbl_users_authentication');
        $user_count = $this->db->count_all_results();
		if($user_count == 0){
			// insert
			$dataArray = array(
								'user_id' => $user_id,
								'token' => $token,
								'login_time' => $login_time,
								'expire_time' => $expire_time
							  );
			if($this->db->insert('tbl_users_authentication', $dataArray)){
				return true;
			}else{
				return false;
			}
		}else{
			// update
			$dataArray = array(
								'token' => $token,
								'login_time' => $login_time,
								'expire_time' => $expire_time
							  );
			$this->db->where('user_id',$user_id);				  
			$up = $this->db->update('tbl_users_authentication', $dataArray);
			if($up){
				return true;
			}else{
				return false;
			}
		}
	}
	
	public function LogoutMe($user_id,$token)
	{
		$this->db->where('token',$token);
		$this->db->where('user_id',$user_id);
		$q1 = $this->db->delete('tbl_users_authentication');
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function SetPassword($user_id,$password)
	{
		$dataArray = array('password'=>md5($password));
		$this->db->where('id',$user_id);
		$q1 = $this->db->update('tbl_users', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function UserStatuschange($user_id,$remark)
	{
		if($remark == 'is_email_verify'){
			$dataArray = array('is_email_verify'=>1);
			$this->db->where('id',$user_id);
		}
		$q1 = $this->db->update('tbl_users', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function UpdateUserData($user_id,$dataArray)
	{
		$this->db->where('id',$user_id);
		$q1 = $this->db->update('tbl_users', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function GetUserById($user_id)
	{
		$this->db->select("*");
		$this->db->where('id' ,$user_id);
		$query = $this->db->get('tbl_users');
		return $query->row();
	}
	
	public function ResetPasswordStatus($user_id,$value)
	{
		$this->db->where('id',$user_id);
		$q1 = $this->db->update('tbl_users', array('reset_password_link'=>$value));
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function UserDeviceTokenUpdate($user_id,$device_token)
	{
		$this->db->where('id',$user_id);
		$updated = $this->db->update('tbl_users', array('token'=>$device_token));
		if($updated){
			return true;
		}else{
			return false;
		}
	}

	public function GetUserDeviceTokenInfo($user_id)
	{
		$this->db->select("id, email, CONCAT_WS(' ',first_name,last_name)  as user_name, token");
		$this->db->from('tbl_users');
		$this->db->where('id',$user_id);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function MyNotification($user_id)
	{
		$this->db->select("*");
		$this->db->from('tbl_notifications');
		$this->db->where('user_id',$user_id);
		// $this->db->where('is_seen',0);
		$this->db->order_by('id','DESC');
		$query = $this->db->get();
		return $query->result();
	}

	public function ChangeUserNotificationStatus($user_id)
	{
		$this->db->where('user_id',$user_id);
		$this->db->where('create_date <= ',date("Y-m-d H:i:s", strtotime("-7 days", strtotime(date("Y-m-d H:i:s")))));			  
		$this->db->where('is_seen',1);			  
		$del = $this->db->delete('tbl_notifications');
		if($del){
			$this->db->where('user_id',$user_id);			  
			$up = $this->db->update('tbl_notifications', array('is_seen'=>1));
			if($up){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}

	public function MyUnreadNotificationCount($user_id)
	{
		$this->db->where('user_id',$user_id);
		$this->db->from('tbl_notifications');
		$this->db->where('is_seen',0);
        $ret = $this->db->count_all_results();
		return $ret;
	}

	public function NotificationDetail($user_id,$notification_id)
	{
		$this->db->select("*");
		$this->db->from('tbl_notifications');
		$this->db->where('user_id',$user_id);
		$this->db->where('id',$notification_id);
		$this->db->where('is_seen',0);
		$query = $this->db->get();
		return $query->row();
	}

	public function GetProfileQuestionTitle($question_id)
	{
		$this->db->select("*");
		$this->db->from('tbl_master_profile');
		$this->db->where('id',$question_id);
		$query = $this->db->get();
		return $query->row();
	}

	public function GetProfileQuestionDetail($question_id)
	{
		$this->db->select("*");
		$this->db->from('tbl_master_profile_detail');
		$this->db->where('mp_id',$question_id);
		$query = $this->db->get();
		return $query->result();
	}

	public function GetAllPremiumPlans()
	{
		$this->db->select("*");
		$this->db->from('tbl_premium_plans');
		$this->db->where('is_active',1);
		$query = $this->db->get();
		return $query->result();
	}

	public function GetPremiumPlanById($user_id)
	{
		$this->db->select("*");
		$this->db->where('id' ,$user_id);
		$query = $this->db->get('tbl_premium_plans');
		return $query->row();
	}

	public function AddTransaction($dataArray)
	{
		$insert = $this->db->insert('tbl_transaction', $dataArray);
		if($insert){
			return true;
		}else{
			return false;
		}
	}

	public function GetSubscriptionStatus($user_id)
	{
		$this->db->select("*");
		$this->db->from('tbl_subscription');
		$this->db->where('user_id' ,$user_id);
		$this->db->order_by('id','DESC');
		$this->db->limit(1);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function AddUpdateSubscriptionStatus($dataArray)
	{
		$this->db->where('user_id' ,$dataArray['user_id']);
		$this->db->from('tbl_subscription');
        $ret = $this->db->count_all_results();
		if($ret > 0){
			// UPDATE
			$this->db->where('user_id' , $dataArray['user_id']);
			$updated = $this->db->update('tbl_subscription',$dataArray);
			if($updated){
				return true;
			}else{
				return false;
			}
		}else{
			// ADD
			$inserted = $this->db->insert('tbl_subscription', $dataArray);
			if($inserted){
				return true;
			}else{
				return false;
			}
		}
	}

	public function GetAdminContactInfo()
	{
		$this->db->select("*");
		$this->db->from('tbl_admin_contact');
		$this->db->order_by('id','DESC');
		$this->db->limit(1);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function GetAllFaq()
	{
		$this->db->select("*");
		$this->db->from('tbl_faq');
		$this->db->order_by('id','DESC');
		$query = $this->db->get();
		return $query->result();
	}













	
	/*
	public function GetPaymentGatewaySetting($paypal_stripe)
	{
		$this->db->select("*");
		$this->db->from('tbl_payment_gateway_setting');
		$this->db->where('gateway',$paypal_stripe);
		$this->db->where('active_status',1);
		$query = $this->db->get();
		return $query->result();
	}
	*/










	
	
	
}
?>