<?php

class User_model extends CI_Model
{
	public function __construct()
	{
		date_default_timezone_set('Asia/Calcutta');
	}
	
	
	public function GetUsersByStatus($status)
	{
		$this->db->select("*");
		$this->db->from('tbl_users');
		$this->db->where('is_account_verify' ,$status);
		$this->db->order_by('id' ,'DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function GetAllUsers()
	{
		$this->db->select("*");
		$this->db->from('tbl_users');
		$this->db->order_by('id' ,'DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function changeUserStatus($user_id,$status)
	{
		$this->db->where('id' ,$user_id);
		$q1 = $this->db->update('tbl_users', array('is_account_verify'=>$status));
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function GetFilteredUsers($by_name, $by_postal_code, $by_city, $by_email, $by_phone, $by_address, $by_date_range)
	{
		$this->db->select("*");
		$this->db->from('tbl_users');
		
		// wildcard search starts here
		
			if($by_name != '' || $by_name != NULL){
				$this->db->like('first_name' ,$by_name);
				$this->db->or_like('last_name' ,$by_name);
			}
			
			if($by_postal_code != '' || $by_postal_code != NULL){
				$this->db->like('postal_code' ,$by_postal_code);
			}
			
			if($by_city != '' || $by_city != NULL){
				$this->db->like('city' ,$by_city);
			}
			
			if($by_email != '' || $by_email != NULL){
				$this->db->like('email' ,$by_email);
			}
			
			if($by_phone != '' || $by_phone != NULL){
				$this->db->like('phone_no' ,$by_phone);
			}
			
			if($by_address != '' || $by_address != NULL){
				$this->db->like('address' ,$by_address);
			}
			
			if($by_date_range != '' || $by_date_range != NULL){
				
				$date_seperate = explode('-',$by_date_range);				
				// $from_date = trim(date('Y-m-d', strtotime($date_seperate[0])));
				// $to_date = trim(date('Y-m-d', strtotime($date_seperate[1])));
				// print_r($from_date.' :: '.$to_date); die;

				$this->db->where('DATE_FORMAT(DATE(created), "%d/%m/%Y") BETWEEN "'.trim($date_seperate[0]). '" and "'.trim($date_seperate[1]).'"');
			}
			
		// wildcard search ends here
		
		$this->db->order_by('id' ,'DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function GetUsersSubscription() 
	{
		$this->db->select("*,
		(select CONCAT_WS(' ',first_name,last_name) from tbl_users where tbl_users.id = tbl_subscription.user_id) as user_name,
		(select is_account_verify from tbl_users where tbl_users.id = tbl_subscription.user_id) as is_account_verify		
						");
		$this->db->from('tbl_subscription');
		$this->db->order_by('id' ,'DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function GetFilteredSubscriptionUsers($by_name, $by_status, $by_date_range)
	{
		//(select CONCAT_WS(' ',first_name,last_name) from tbl_users where tbl_users.id = tbl_subscription.user_id) as user_name

		$this->db->select("
							tbl_subscription.id as id,
							tbl_subscription.user_id as user_id,
							tbl_subscription.subscription_date as subscription_date,
							tbl_subscription.expire_date as expire_date,
							CONCAT_WS(' ',tbl_users.first_name,tbl_users.last_name) as user_name,
							tbl_users.is_account_verify
						");
		$this->db->from('tbl_subscription');
		
		$this->db->join('tbl_users','tbl_users.id = tbl_subscription.user_id');
		// wildcard search starts here
			if($by_status != '' || $by_status != NULL){
				if($by_status == 'active'){
					$this->db->where('expire_date >' , date("Y-m-d H:i:s"));
				}else{
					$this->db->where('expire_date <' , date("Y-m-d H:i:s"));
				}
			}
			if($by_date_range != '' || $by_date_range != NULL){
				$date_seperate = explode('-',$by_date_range);
				
				$fdate = explode('/',trim($date_seperate[0]));
				$from_date = $fdate[2].'-'.$fdate[1].'-'.$fdate[0];

				$tdate = explode('/',trim($date_seperate[1]));
				$to_date = $tdate[2].'-'.$tdate[1].'-'.$tdate[0];
				
				$search_where = 'CAST(expire_date As Date) BETWEEN "'.$from_date.'" AND "'.$to_date.'"';
				$this->db->where($search_where);
			}
			if($by_name != '' || $by_name != NULL){
				$this->db->like('tbl_users.first_name' ,$by_name);
				$this->db->or_like('tbl_users.last_name' ,$by_name);
			}
		// wildcard search ends here
		$this->db->order_by('id' ,'DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function GetUserList()
	{
		$this->db->select("id, email, CONCAT_WS(' ',first_name,last_name)  as user_name	");
		$this->db->from('tbl_users');
		$this->db->order_by('id' ,'ASC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function GetUserById($user_id)
	{
		$this->db->select("*");
		$this->db->where('id' ,$user_id);
		$query = $this->db->get('tbl_users');
		return $query->row();
	}
	
	public function AddNotificationInfo($dataArray)
	{
		$q1 = $this->db->insert('tbl_notifications', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function GetUsersTransaction() 
	{
		$this->db->select("*");
		$this->db->from('tbl_transaction');
		$this->db->order_by('id' ,'DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function GetFilteredTransactions($by_txn_id, $by_user, $by_email, $by_bank, $by_date_range)
	{
		$this->db->select("*");
		$this->db->from('tbl_transaction');
	
		if($by_bank != '' && $by_bank != NULL)
		{
			$this->db->where('payment_bank' ,$by_bank);
		}
		
		if($by_date_range != '' || $by_date_range != NULL)
		{
			$date_seperate = explode('-',$by_date_range);
			
			$fdate = explode('/',trim($date_seperate[0]));
			$from_date = $fdate[2].'-'.$fdate[1].'-'.$fdate[0];

			$tdate = explode('/',trim($date_seperate[1]));
			$to_date = $tdate[2].'-'.$tdate[1].'-'.$tdate[0];
			
			$search_where = 'CAST(payment_date As Date) BETWEEN "'.$from_date.'" AND "'.$to_date.'"';
			$this->db->where($search_where);
		}

		if($by_user != '' && $by_user != NULL)
		{
			$this->db->like('user_name' ,$by_user);
		}

		if($by_email != '' && $by_email != NULL)
		{
			$this->db->like('user_email' ,$by_email);
		}

		if($by_txn_id != '' && $by_txn_id != NULL)
		{
			$this->db->like('txn_id' ,$by_txn_id);
		}
		
		$query = $this->db->get();
		return $query->result();
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
}
?>