<?php

class Webadmin_model extends CI_Model
{
	public function __construct()
	{
		date_default_timezone_set('Asia/Calcutta');
	}
	
	public function GetDashboardCounts()
	{
		$this->db->select("
							(select count(*) from tbl_users where type = 1) as count_users,
							(select count(*) from tbl_users where type = 2) as count_advertisers,
							(select count(*) from tbl_category_1) as count_main_category,
							(select count(*) from tbl_category_2) as count_sub_category,
							(select count(*) from tbl_ad) as count_ad,
							(select CONCAT_WS(' ',sum(amount),'€') from tbl_transaction) as count_subscription,
							(select count(*) from ecomm_products) as count_products,
							(select count(*) from ecomm_order) as count_orders
						");
		$this->db->from('tbl_users');
		$query = $this->db->get();
		return $query->row();
	}

	public function isUserExist($val)
	{
		$this->db->from('tbl_admin');
        $ret = $this->db->count_all_results();
		if ($ret == 0){
			return false;
		}else{
			$this->db->select("*");
			$this->db->where('email_id' ,$val);
			$this->db->from('tbl_admin');
			$query = $this->db->get();
			return $query->row();
		}
	}
	
	public function GetPassword($id)
	{
		$this->db->select("password");
		$this->db->where('id' ,$id);
		$this->db->from('tbl_admin');
		$query = $this->db->get();
		return $query->row();
	}
	
	public function UpdatePassword($admin_id,$pass)
	{
		$this->db->where('id',$admin_id);
		$q1 = $this->db->update('tbl_admin', array('password'=>$pass));
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function GetAdminContactInfo()
	{
		$this->db->select("*");
		$this->db->from('tbl_admin_contact');
		$this->db->order_by('id','DESC');
		$this->db->limit(1);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function UpdateContactInfo($dataArray)
	{
		$this->db->where('id',1);
		$q1 = $this->db->update('tbl_admin_contact',$dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function GetAllFaqs()
	{
		$this->db->select("*");
		$this->db->from('tbl_faq');
		$this->db->order_by('id','DESC');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function AddFaq($dataArray)
	{
		$q1 = $this->db->insert('tbl_faq', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function UpdateFaq($dataArray,$faq_id)
	{
		$this->db->where('id',$faq_id);
		$q1 = $this->db->update('tbl_faq',$dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function DeleteFaq($faq_id)
	{
		$this->db->where('id' ,$faq_id);
		$q1 = $this->db->delete('tbl_faq');
		if($q1){
			return true;
		}else{
			return false;
		}
	}
	
	public function GetPaymentGatewaySetting($paypal_stripe)
	{
		$this->db->select("*");
		$this->db->from('tbl_payment_gateway_setting');
		$this->db->where('gateway',$paypal_stripe);
		$this->db->where('active_status',1);
		$query = $this->db->get();
		return $query->result();
	}
	
	public function UpdatePaymentGatewaySetting($bank,$demo_live)
	{
		$this->db->set('active_status','CASE WHEN `active_status`=1 THEN 0 ELSE 1 END',false);
		$this->db->where('gateway' ,$bank);
		$q1 = $this->db->update('tbl_payment_gateway_setting');
		// echo $this->db->last_query(); die;
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function UpdatePaymentGatewayData($payment_bank,$payment_mode,$dataArray)
	{
		if($payment_bank == 'stripe')
		{
			$publishable_key = $dataArray['publishable_key'];
			$secret_key = $dataArray['secret_key'];

			if($payment_mode == 0)
			{
				// test mode
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,9);
				$query_1 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$publishable_key,'updated'=>date("Y-m-d H:i:s")));
				
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,10);
				$query_2 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$secret_key,'updated'=>date("Y-m-d H:i:s")));
			
				if($query_1 && $query_2){
					return true;
				}else{
					return false;
				}
			}

			if($payment_mode == 1)
			{
				// live mode
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,11);
				$query_1 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$publishable_key,'updated'=>date("Y-m-d H:i:s")));
				
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,12);
				$query_2 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$secret_key,'updated'=>date("Y-m-d H:i:s")));
					
				if($query_1 && $query_2){
					return true;
				}else{
					return false;
				}
			}
		}

		if($payment_bank == 'paypal')
		{
			$business_email = $dataArray['business_email'];
			$account_id = $dataArray['account_id'];
			$client_id = $dataArray['client_id'];
			$secret_id = $dataArray['secret_id'];

			if($payment_mode == 0)
			{
				// test mode
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,1);
				$query_1 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$business_email,'updated'=>date("Y-m-d H:i:s")));
				
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,2);
				$query_2 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$account_id,'updated'=>date("Y-m-d H:i:s")));
				
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,3);
				$query_3 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$client_id,'updated'=>date("Y-m-d H:i:s")));

				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,4);
				$query_4 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$secret_id,'updated'=>date("Y-m-d H:i:s")));

				if($query_1 && $query_2 && $query_3 && $query_4){	
					return true;
				}else{
					return false;
				}
			}

			if($payment_mode == 1)
			{
				// live mode
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,5);
				$query_1 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$business_email,'updated'=>date("Y-m-d H:i:s")));
				
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,6);
				$query_2 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$account_id,'updated'=>date("Y-m-d H:i:s")));
				
				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,7);
				$query_3 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$client_id,'updated'=>date("Y-m-d H:i:s")));

				$this->db->where('live_demo' ,$payment_mode);
				$this->db->where('gateway' ,$payment_bank);
				$this->db->where('id' ,8);
				$query_4 = $this->db->update('tbl_payment_gateway_setting',array('pay_value'=>$secret_id,'updated'=>date("Y-m-d H:i:s")));

				if($query_1 && $query_2 && $query_3 && $query_4){	
					return true;
				}else{
					return false;
				}
			}
		}
	}

	public function GetAllMasterProfile()
	{
		$this->db->select("*");
		$this->db->from('tbl_master_profile');
		$this->db->order_by('id','DESC');
		$query = $this->db->get();
		return $query->result();
	}

	public function AdMasterProfile($dataArray)
	{
		$q1 = $this->db->insert('tbl_master_profile', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function UpdateMasterProfile($id,$dataArray)
	{
		$this->db->where('id' ,$id);
		$q1 = $this->db->update('tbl_master_profile', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function DeleteMasterProfile($id)
	{
		$this->db->where('id' ,$id);
		$q1 = $this->db->delete('tbl_master_profile');
		if($q1){
			$this->db->where('mp_id' ,$id);
			$q1 = $this->db->delete('tbl_master_profile_detail');
			if($q1){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	
	public function GetMasterProfileTitleDetail($title_id)
	{
		$this->db->select("*");
		$this->db->from('tbl_master_profile_detail');
		// $this->db->order_by('id','DESC');
		$this->db->where('mp_id' ,$title_id);
		$query = $this->db->get();
		return $query->result();
	}

	public function add_profile_title_detail($title_id,$title)
	{
		$dataArray = array(
							'mp_id' => $title_id,
							'title'=>$title,
							'create_date'=>date("Y-m-d"),
							'update_date'=>date("Y-m-d")
						);
		$q1 = $this->db->insert('tbl_master_profile_detail', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function delete_profile_title_detail($title_detail_id)
	{
		$this->db->where('id' ,$title_detail_id);
		$q1 = $this->db->delete('tbl_master_profile_detail');
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function AddPremiumPlan($dataArray)
	{
		$q1 = $this->db->insert('tbl_premium_plans', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function UpdatePremiumPlan($plan_id,$dataArray)
	{
		$this->db->where('id' ,$plan_id);
		$q1 = $this->db->update('tbl_premium_plans', $dataArray);
		if($q1){
			return true;
		}else{
			return false;
		}
	}

	public function GetAllPremiumPlans()
	{
		$this->db->select("*");
		$this->db->from('tbl_premium_plans');
		$this->db->order_by('id','DESC');
		$query = $this->db->get();
		return $query->result();
	}

	public function DeletePremiumPlan($id)
	{
		$this->db->where('id' ,$id);
		$q1 = $this->db->delete('tbl_premium_plans');
		if($q1){
			return true;
		}else{
			return false;
		}	
	}

	public function GetPremiumPlan($id)
	{
		$this->db->select("*");
		$this->db->from('tbl_premium_plans');
		$this->db->where('id' ,$id);
		$query = $this->db->get();
		return $query->row();
	}






	
	
	
	
	
}
?>