$( document ).ready(function() {
	
	var sess_lang = $('#sess_lang').val();
		
	/*************** NO SPACE VALIDATOR START ***************/
	jQuery.validator.addMethod("noSpace", function(value, element) { 
	  return value == '' || value.trim().length != 0;  
	}, (sess_lang == 'en') ? "No space please." : "Pas de place s'il vous plaît.");
	/*************** NO SPACE VALIDATOR ENDS ***************/
	
	
	/*************** WEBADMIN LOGIN STARTS ***************/
	$(function() {
	  $("form[name='wa_login_form']").validate({
		rules: {
		  wa_email: {
			required: true,
			noSpace: true,
			email: true
		  },
		  wa_password: {
			  required: true,
			  noSpace: true
		  }
		},
		
		messages: {
		  wa_email: {
			required: (sess_lang == 'en') ? "email address required." : "adresse électronique requise.",
			email: (sess_lang == 'en') ? "enter a valid email address." : "entrez une adresse électronique valide."
		  },
		  wa_password: { 
			required : (sess_lang == 'en') ? "password required." : "mot de passe requis."
		  }
		},
		
		submitHandler: function(form) {
		  
			$('#wa_login_form').waitMe({ maxSize:'48', effect: 'roundBounce', color: '#0087E0' });
			
			$('.e_msg, .s_msg').remove();
			
			var dataString = $("#wa_login_form").serialize();
			
			$('.sgin_bt_1').prop('disabled', true);
			$('.sgin_bt_1').text((sess_lang == 'en') ? "Please Wait..." : "S'il vous plaît, attendez...");
						
			$.ajax({
				type: "POST",
				url: $('#base_url').val()+"webadmin/login/DoLogin",
				dataType: "json",
				data:dataString,
				success: function(data){
					
					$('.sgin_bt_1').prop('disabled', false);
					$('.sgin_bt_1').text((sess_lang == 'en') ? 'Sign In' : "Se connecter");
					
					$('#wa_login_form').waitMe('hide');
					
					if(data.response == 0){
						$('.sgin_bt_1').after('<div class="e_msg"> '+data['msg']+' </div>');
						setTimeout(function(){ 
							$('.e_msg').fadeOut(5000);
						}, 15000);
					}else if(data.response == 1){
						$('.sgin_bt_1').after('<div class="s_msg"> '+data['msg']+' </div>');
						$('#wa_login_form').trigger('reset');
						setTimeout(function(){ 
							$('.s_msg').fadeOut(1500);
							location.reload(true);
						}, 1000);
					}else {
						$('.sgin_bt_1').after('<div class="e_msg"> Sorry ! We are unable to process your request due to some technical issue. </div>');
						setTimeout(function(){ 
							$('.e_msg').fadeOut(5000);
						}, 15000);
					}
				}
			});
			return false;
		
		}
	  });
	});
	/*************** WEBADMIN LOGIN ENDS ***************/



	
	/*************** CHANGE PASSWORD STARTS ***************/
	$(document).on('click', '.fa-fw', function(){
		var this_id = $(this).data('id');
		var this_in = $('#'+this_id).val();
		
		if(this_in != '' && this_in != null)
		{
			var x = document.getElementById(this_id);
			if (x.type === "password") 
			{
				x.type = "text";
				$(this).css('display','none');
				$(this).next('i').css('display','');
			} 
			else 
			{
				x.type = "password";
				$(this).css('display','none');
				$(this).prev('i').css('display','');
			}
		}
	});
	
	$(function() {
	  $("form[name='change_passord_form']").validate({
		rules: {
		  pass_1: {
			required: true,
			noSpace: true,
		  },
		  pass_2: {
			  required: true,
			  noSpace: true
		  },
		  pass_3: {
			  required: true,
			  noSpace: true,
			  equalTo : "#pass_2"
		  }
		},
		
		messages: {
		  pass_1: {
			required: (sess_lang == 'en') ? "password required." : "mot de passe requis.",
		  },
		 pass_2: {
			required: (sess_lang == 'en') ? "password required." : "mot de passe requis.",
		  },
		  pass_3: {
			required: (sess_lang == 'en') ? "password required." : "mot de passe requis.",
			equalTo : (sess_lang == 'en') ? "confirm password should be same as new password !" : "le mot de passe de confirmation doit être le même que le nouveau mot de passe !"
		  }
		},
		
		submitHandler: function(form) {
		  
			$('.e_msg, .s_msg').remove();
			
			var dataString = $("#change_passord_form").serialize();
			
			$('.sgin_bt_1').prop('disabled', true);
			$('.sgin_bt_1').text((sess_lang == 'en') ? 'Please Wait...' : "S'il vous plaît, attendez...");
						
			$.ajax({
				type: "POST",
				url: $('#base_url').val()+"webadmin/dashboard/changepassword",
				dataType: "json",
				data:dataString,
				success: function(data){
					
					$('.sgin_bt_1').prop('disabled', false);
					$('.sgin_bt_1').text('SUBMIT');
							
					if(data.response == 0){
						$('.sgin_bt_1').after('<div class="pull-left e_msg"> '+data['msg']+' </div>');
						setTimeout(function(){ 
							$('.e_msg').fadeOut(5000);
						}, 2000);
					}else if(data.response == 1){
						$('.sgin_bt_1').after('<div class="pull-left s_msg"> '+data['msg']+' </div>');
						$('#change_passord_form').trigger('reset');
						setTimeout(function(){ 
							$('.s_msg').fadeOut(5000);
						}, 2000);
					}else {
						$('.sgin_bt_1').after('<div class="pull-left e_msg"> Sorry ! We are unable to process your request due to some technical issue. </div>');
						setTimeout(function(){ 
							$('.e_msg').fadeOut(5000);
						}, 2000);
					}
				}
			});
			return false;
		
		}
	  });
	});
	/*************** CHANGE PASSWORD ENDS ***************/
	
	
	
	
	/*************** LOGOUT STARTS ***************/
	$(document).on('click', '#SignoutMe', function(){
		$.post( $('#base_url').val()+"webadmin/dashboard/signout", { }, function( data ) {
			if(data.response == 1){
				alert(data.msg);
				setTimeout(function(){
					window.location.href = $('#base_url').val()+"webadmin";	
				},1500);
			}
		}, "json");
	});
	/*************** LOGOUT ENDS ***************/
	
	

});